<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2009 Kurt Gusbeth <info@myquizandpoll.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');
require_once(PATH_BE_myquizpoll.'pi1/class.tx_myquizpoll_helper.php');

/**
 * Plugin 'My quiz and poll' for the 'myquizpoll' extension.
 *
 * @author	Kurt Gusbeth <info@myquizandpoll.de>
 * @package	TYPO3
 * @subpackage	tx_myquizpoll
 */
class tx_myquizpoll_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_myquizpoll_pi1';				// Same as class name
	var $scriptRelPath = 'pi1/class.tx_myquizpoll_pi1.php';	// Path to this script relative to the extension directory
	var $extKey        = 'myquizpoll';						// The extension key.
	var $conf = array();
	var $answerChoiceMax = 5;								// This max cannot be changed without changing the TCA (and DB)!
	var $lang = 0;											// language
	var $templateCode = '';
	var $origTemplateCode = '';
	var $xajax;
	
	/**
	 * Main method of your PlugIn
	 *
	 * @param	string		$content: The content of the PlugIn
	 * @param	array		$conf: The PlugIn Configuration
	 * @return	The content that should be displayed on the website
	 */
	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_initPIflexForm(); // Init FlexForm configuration for plugin 
		$this->pi_loadLL();
		$this->pi_USER_INT_obj=1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
		$thePID = 0;				// PID of the sysfolder
		$nextPID = 0;				// PID for forms
		$finalPID = 0;				// PID for the final page
		$listPID = 0;				// PID for highscore or poll result
		$startPID = 0;				// PID of the startpage
		$uid = 0;					// quiz taker UID?!
		//$firsttime = 0;			// start time of the quiz
		$elapseTime = 0;			// intval($this->conf['quizTimeMinutes'])*60;			// Verflossene Zeit in Sekunden
		$joker1 = 0;				// Joker used?
		$joker2 = 0;
		$joker3 = 0;
		$startPage = false;			// start page which asks only for user data?
		$questionPage = false;		// question page?
		$answerPage = false;		// answer page?
		$finalPage = false;			// final page reached?
		$noQuestions = false;		// no more questions?

		// global $TSFE;
		$this->lang = $GLOBALS['TSFE']->config['config']['sys_language_uid']; 
		//$this->lang = $_GET['L'];
		//if ($this->lang == '') $this->lang = $_POST['L'];
		if ($this->lang == '') $this->lang = 0;		// falls keine Sprache gesetzt wurde
		
		$this->copyFlex();			// copy Felxform-Variables to this->conf
		
		if ( $this->conf['enableCaptcha'] && t3lib_extMgm::isLoaded('sr_freecap') ) {		// load Captcha: Anti-Spam-Tool ??? only if enabled (16.10.2009)
			require_once(t3lib_extMgm::extPath('sr_freecap').'pi2/class.tx_srfreecap_pi2.php');
			$this->freeCap = t3lib_div::makeInstance('tx_srfreecap_pi2');
		}
		
		if( !($this->cObj->data['pages'] == '') ) {		// PID
			$thePID = $this->cObj->data['pages'];
		} elseif( !($this->conf['sysPID'] == '') )  { 
			$thePID = $this->conf['sysPID']; 
		} else { 
			$thePID = $GLOBALS["TSFE"]->id;
		}
		$nextPID  = ($this->conf['nextPID'])  ? intval($this->conf['nextPID'])  : $GLOBALS['TSFE']->id;
		$finalPID = ($this->conf['finalPID']) ? intval($this->conf['finalPID']) : $GLOBALS['TSFE']->id;	// oder $nextPID;
		$listPID  = ($this->conf['listPID'])  ? intval($this->conf['listPID'])  : $GLOBALS['TSFE']->id;	// oder $finalPID;
		$startPID = ($this->conf['startPID']) ? intval($this->conf['startPID']) : $GLOBALS['TSFE']->id;
		
		if ($this->conf['answerChoiceMax'])					// antworten pro fragen
			$this->answerChoiceMax = intval($this->conf['answerChoiceMax']);
		
		mt_srand(hexdec(substr(md5(microtime()), -8)) & 0x7fffffff);  // Seed random number generator
		$this->local_cObj = t3lib_div::makeInstance("tslib_cObj");	// Local cObj
		$quiz_taker_ip_address = t3lib_div::getIndpEnv("REMOTE_ADDR");	// Collect ip address of quiz taker
		
		// Get post parameters: Submited Quiz-data
		$quizData = array();
		if (is_array(t3lib_div::GPvar($this->prefixId))) {
		  $quizData = t3lib_div::slashArray(t3lib_div::GPvar($this->prefixId),"strip");
		  if ($quizData["cmd"]=='') {
		    $quizData["cmd"] = $this->conf['CMD'];
		  } elseif ($quizData["cmd"]=='allanswers') {	// or $quizData["cmd"]=='score' or $quizData["cmd"]=='list'
		    $quizData["cmd"] = '';						// for security reasons we want that users can´t see everything
		  }
		} else {
		  $quizData["cmd"] = $this->conf['CMD'];		// get the CMD from the backend
		}
		
		// Load template
		$this->initTemplate();
		
		// Marker values
		$statisticsArray=array();
		$markerArray=array();
		$subpartArray=array();
		$wrappedSubpartArray=array();
		$markerArrayP=array();
		$markerArrayP["###REF_HIGHSCORE###"] = '';
		$markerArrayP["###REF_HIGHSCORE_URL###"] = '';
		$markerArrayP["###REF_POLLRESULT_URL###"] = '';		
		$markerArrayP["###REF_QUIZ_ANALYSIS###"] = '';
		$markerArrayP["###REF_NO_MORE###"] = '';
		$markerArrayP["###REF_ERRORS###"] = '';
		$markerArrayP["###REF_RES_ERRORS###"] = '';
		$markerArrayP["###REF_JOKERS###"] = '';
		$markerArrayP["###REF_QUESTIONS###"] = '';
		$markerArrayP["###REF_QRESULT###"] = '';
		$markerArrayP["###REF_INTRODUCTION###"] = '';
		$markerArrayP["###REF_QPOINTS###"] = '';
		$markerArrayP["###REF_SKIPPED###"] = '';
		$markerArrayP["###REF_NEXT###"] = '';
		$markerArrayP["###REF_POLLRESULT###"] = '';
		$markerArrayP["###PREFIX###"] = $this->prefixId;
		$markerArrayP["###FORM_URL###"] = $this->pi_getPageLink($nextPID);
		$markerArray["###PREFIX###"] = $this->prefixId;
		$markerArray["###FORM_URL###"] = $markerArrayP["###FORM_URL###"];
		$markerArray["###QUIZ_NAME###"] = $this->conf['quizName'];
		$markerArray["###NAME###"] = $this->pi_getLL('name','name');
		$markerArray["###EMAIL###"] = $this->pi_getLL('email','email');
		$markerArray["###HOMEPAGE###"] = $this->pi_getLL('homepage','homepage');
		$markerArray["###GO_ON###"] = $this->pi_getLL('go_on','go_on');
		$markerArray["###SUBMIT###"] = $this->pi_getLL('submit','submit');
		$markerArray["###RESET###"] = $this->pi_getLL('reset','reset');
		$markerArray["###CORRECT_ANSWERS###"] = $this->pi_getLL('correct_answers','correct_answers');
		$markerArray["###EXPLANATION###"] = $this->pi_getLL('listFieldHeader_explanation', 'listFieldHeader_explanation');
		$markerArray["###VAR_TOTAL_POINTS###"] = '';
		if ($this->conf['pageTimeSeconds'] || $this->conf['quizTimeMinutes']) {
			$markerArray["###TIME_UP1###"] = $this->pi_getLL('time_up1','time_up1');
			$markerArray["###LIMIT1A###"] = $this->pi_getLL('limit1a','limit1a');
			$markerArray["###LIMIT1B###"] = $this->pi_getLL('limit1b','limit1b');
			$markerArray["###TIME_UP2###"] = $this->pi_getLL('time_up2','time_up2');
			$markerArray["###LIMIT2A###"] = $this->pi_getLL('limit2a','limit2a');
			$markerArray["###LIMIT2B###"] = $this->pi_getLL('limit2b','limit2b');
			$markerArray["###SECONDS###"] = $this->pi_getLL('seconds','seconds');
			$markerArray["###MINUTES###"] = $this->pi_getLL('minutes','minutes');
		}		
		// Link to the Highscore list
  		$urlParameters = array("tx_myquizpoll_pi1[cmd]" => "score", "tx_myquizpoll_pi1[qtuid]" => $quizData["qtuid"], "no_cache" => "1");
		$markerArray["###HIGHSCORE_URL###"] = $this->pi_linkToPage($this->pi_getLL('highscore_url','highscore_url'), $listPID, $target = '', $urlParameters);
		
		// Jokers
		if ($this->conf['useJokers'] && $this->conf['pageQuestions']==1) {
			/*
			*  Instantiate the xajax object and configure it
			*/
			require_once (t3lib_extMgm::extPath('xajax') . 'class.tx_xajax.php');		// Include xaJax
			$this->xajax = t3lib_div::makeInstance('tx_xajax'); // Make the instance
			# $this->xajax->setRequestURI('xxx'); 		// nothing to set, we send to the same URI
			# $this->xajax->decodeUTF8InputOn(); // Decode form vars from utf8 ???
			# $this->xajax->setCharEncoding('utf-8'); // Encode of the response to utf-8 ???
			$this->xajax->setWrapperPrefix($this->prefixId); // To prevent conflicts, prepend the extension prefix
			$this->xajax->statusMessagesOff(); // Do you wnat messages in the status bar?
			$this->xajax->debugOff(); // Turn only on during testing
			$this->xajax->registerFunction(array('getAjaxData', &$this, 'getAjaxData')); // Register the names of the PHP functions you want to be able to call through xajax - $xajax->registerFunction(array('functionNameInJavascript', &$object, 'methodName'));
			$this->xajax->processRequests();// If this is an xajax request, call our registered function, send output and exit
			$GLOBALS['TSFE']->additionalHeaderData[$this->prefixId] = $this->xajax->getJavascript(t3lib_extMgm::siteRelPath('xajax'));// Else create javascript and add it to the header output
			
			$markerArrayJ=array();
			$markerArrayJ["###PREFIX###"] = $this->prefixId;
			$markerArrayJ["###USE_JOKERS###"] = $this->pi_getLL('use_jokers','use_jokers');
			$markerArrayJ["###ANSWER_JOKER###"] = $this->pi_getLL('answer_joker','answer_joker');			
		}

		// Init
		$no_rights = 0;			// second entry of the quiz taker or not logged in if requiered?
//		$leftQuestions = 0;		// no. of questions to be shown
		$whereAnswered = '';	// questions that have been allready answered (UIDs)
		$whereSkipped = '';		// questions that have been skipped (UIDs)
		$content = '';			// content to be shown
		$tableQuestions = 'tx_myquizpoll_question';
		$tableAnswers   = 'tx_myquizpoll_result';
		$tableRelation  = 'tx_myquizpoll_relation';

		$helperObj = new tx_myquizpoll_helper(
			$thePID, 
			$this->lang,
			$this->answerChoiceMax,
			$tableQuestions, 
			$tableAnswers, 
			$tableRelation, 
			$conf
		);
		
		// set some session-variables
		if ((!$this->conf['isPoll']) && ($quizData["cmd"]=='') && (!$quizData["qtuid"]))
			$helperObj->setQuestionsVars();
		
		// check, if logged in
		if ( $this->conf['loggedInCheck'] && $quizData["cmd"]!='score' && !$GLOBALS['TSFE']->loginUser ) {
			$no_rights = 1;					// noname user is (b)locked now
			$markerArray["###NOT_LOGGEDIN###"] = $this->pi_getLL('not_loggedin','not_loggedin');
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_NOT_LOGGEDIN###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArray);  	// Sonderfall !!!
		}

		// check for second entry ( based on the ip-address )
		if ( $this->conf['doubleEntryCheck'] && $quizData["cmd"]!='score' && !$quizData["qtuid"] && $no_rights == 0 ) {
			$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery( 'tstamp, uid',
															$tableAnswers,
															'pid='.$thePID." AND ip='".$quiz_taker_ip_address."' AND sys_language_uid=".
																$this->lang.' '.$this->cObj->enableFields($tableAnswers),
															'',
															'tstamp DESC',
															'1');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
			if ($rows>0) {							// DB entry found for current user?
				$fetchedRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5);
				$dateOld = $fetchedRow['tstamp'];
				$period = intval($this->conf['doubleEntryCheck']);	// seconds
				if ($period < 10000) $period *= 60*60*24;		// days
				//if ($period==1) $period = 50000;		// approx. a half day is the quiz blocked for the same ip-address
				if ((time() - $dateOld) < $period) {
					if ( $this->conf['doubleCheckMode'] ) {
						$quizData["qtuid"] = $fetchedRow['uid'];
						$quizData["cmd"]  = 'next';
					} else {
						$no_rights = 1;						// user is (b)locked now
						$markerArray["###DOUBLE_ENTRY###"] = $this->pi_getLL('double_entry','double_entry');
						$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_DOUBLE_ENTRY###");
						$content .= $this->cObj->substituteMarkerArray($template, $markerArray);		 // Sonderfall !!!
					}
				}
			}
		}
		
		// check if the captcha is OK
		if (($quizData["cmd"]  == 'submit' || $quizData["fromStart"]) && is_object($this->freeCap) && ($this->conf['enableCaptcha']==1 || ($this->conf['enableCaptcha']==2 && $quizData["fromStart"])) && !$this->freeCap->checkWord($quizData['captcha_response']) && $no_rights == 0) {
			if ($quizData["fromStart"] && $startPID!=$GLOBALS["TSFE"]->id) {	// Weiterleitung zurueck zur Extra-Startseite
				header( 'Location: '.t3lib_div::locationHeaderUrl($this->pi_getPageLink($startPID,'',array($this->prefixId.'[name]' => $quizData["name"],$this->prefixId.'[email]' => $quizData["email"],$this->prefixId.'[homepage]' => $quizData["homepage"], $this->prefixId.'[captchaError]' => '1'))) );
				break;
			}
			$quizData["cmd"]  = ($quizData["fromStart"]) ? '' : 'next';		// "nochmal" simulieren
			//$quizData["qtuid"] = '';		// wieso wohl???
			$markerArray["###CAPTCHA_NOT_OK###"] = $this->pi_getLL('captcha_not_ok','captcha_not_ok');
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_CAPTCHA_NOT_OK###");
			$markerArrayP["###REF_ERRORS###"] .= $this->cObj->substituteMarkerArray($template, $markerArray);	// instead of $content
			if ($quizData["fromStart"]) $quizData["fromStart"] = 0;			// nichts wurde getan simulieren
		} else if ($quizData["captchaError"]) {
			$markerArray["###CAPTCHA_NOT_OK###"] = $this->pi_getLL('captcha_not_ok','captcha_not_ok');
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_CAPTCHA_NOT_OK###");
			$markerArrayP["###REF_ERRORS###"] .= $this->cObj->substituteMarkerArray($template, $markerArray);	// instead of $content
		}
		
		// read quiz takers old data
		$answeredQuestions = 0;     // prev. answered Question(s)
		if ((($this->conf['useCookiesInDays']>0 && !$quizData["qtuid"]) || 
			 ($quizData["cmd"]  == 'next') ||
			 ($quizData["cmd"]  == 'submit' && !$this->conf['isPoll'] && (!$this->conf['dontShowPoints'] || $this->conf['quizTimeMinutes']))) && $no_rights == 0 ) {
			 
			if (!$quizData["qtuid"] && !($quizData["cmd"]  == 'next' || $quizData["cmd"]  == 'submit'))
				$quizData["qtuid"] = $_COOKIE["myquizpoll".$thePID];	// read quiz taker UID and from a cookie
			// oder? $HTTP_COOKIE_VARS["myquizpoll".$thePID];    oder?  $GLOBALS["TSFE"]->fe_user->getKey("ses","myquizpoll".$thePID); 
			
			if ($quizData["qtuid"]) {	// load solved questions and quiz takers name, email, homepage, old points and last time
				$uid = intval($quizData["qtuid"]);
				$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('name, email, homepage, qids, sids, p_or_a, p_max, percent, o_max, o_percent, firsttime, joker1,joker2,joker3',
					$tableAnswers,
					'uid='.$uid.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableAnswers),
					'',
					'',
					'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
				if ($rows>0) {							// DB entry found for current user?
					$fetchedRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5);
					$answeredQuestions = $fetchedRow['qids'];
					$skipped = $fetchedRow['sids'];
					$joker1 = $fetchedRow['joker1'];
					$joker2 = $fetchedRow['joker2'];
					$joker3 = $fetchedRow['joker3'];
					$firsttime = intval($fetchedRow['firsttime']);
					$helperObj->setFirstTime($uid, $firsttime);
					if ($answeredQuestions && !$this->conf["isPoll"]) {
						if ($quizData["cmd"]  != 'submit') {			// namen nicht überschreiben
							$whereAnswered = ' AND uid NOT IN ('.$answeredQuestions.')';	// exclude answered questions next time
							$quizData["name"] = $fetchedRow['name'];
							$quizData["email"] = $fetchedRow['email'];
							$quizData["homepage"] = $fetchedRow['homepage'];
						}
						$markerArray["###VAR_TOTAL_POINTS###"] = intval($fetchedRow['p_or_a']);		// save total points for the case there are no more questions
						$markerArray["###VAR_TMAX_POINTS###"] = intval($fetchedRow['p_max']);
						$markerArray["###VAR_TMISSING_POINTS###"] = intval($fetchedRow['p_max']) - intval($fetchedRow['p_or_a']);
						$markerArray["###VAR_PERCENT###"] = intval($fetchedRow['percent']);
						$markerArray["###VAR_OMAX_POINTS###"] = intval($fetchedRow['o_max']);
						$markerArray["###VAR_OVERALL_PERCENT###"] = intval($fetchedRow['o_percent']);
						$elapseTime = time() - $firsttime;
					}
					if ($skipped && !$this->conf["isPoll"] && $quizData["cmd"]  != 'submit') {
						$whereSkipped = ' AND uid NOT IN ('.$skipped.')';	// exclude skipped questions next time
					}
				}
			} else if ($this->conf['quizTimeMinutes'] && $quizData["time"]) {
				$elapseTime = time() - intval($quizData["time"]);		// before saving data
			}
		}
		
		// check, if quiz is cancled
		if ( $this->conf['quizTimeMinutes'] && ((intval($this->conf['quizTimeMinutes'])*60 - $elapseTime)<=0) ) {     // oder $quizData['cancel'] == 1 ) {
			$markerArray["###REACHED1###"] = $this->pi_getLL('reached1','reached1');
			$markerArray["###REACHED2###"] = $this->pi_getLL('reached2','reached2');
			$markerArray["###SO_FAR_REACHED1###"] = $this->pi_getLL('so_far_reached1','so_far_reached1');
			$markerArray["###SO_FAR_REACHED2###"] = $this->pi_getLL('so_far_reached2','so_far_reached2');
			$markerArray["###QUIZ_END###"] = $this->pi_getLL('quiz_end','quiz_end');
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_END###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArray);		// sonderfall !!!
			
			if ( $this->conf['finalWhenCancel'] ) {
				$noQuestions = true;
			} else {
				if ( $this->conf['showHighscore'] ) {
					$quizData["cmd"] = 'score';		// show highscore
				} else {
					$quizData["cmd"] = 'exit';		// display no more questions
				}
				$no_rights = 1;					// cancel all				
			}
		}

		// show only a start page?
		if ($this->conf['userData.']['askAtStart'] && !$quizData["qtuid"] && !$quizData["cmd"] && !$quizData["fromStart"]) {		// show only "ask for user data"?
			$startPage = true;
			$quizData["cmd"] = 'start';
		}
			
		// next page is a page with questions...
		if ($quizData["cmd"] == 'next')
			$quizData["cmd"] = '';
		
				
		
		if( $quizData["cmd"] == 'submit' && $no_rights == 0 ) {   /* ***************************************************** */
			/*
			 * Display result page: answers and points
			 */

			// Check quiz taker name and email
			if ( trim($quizData["name"]) == "" ) {
				$quizData["name"] = $this->pi_getLL('no_name','no_name');
			}
			if ( !(t3lib_div::validEmail(trim($quizData["email"]))) ) {
				$quizData["email"] = $this->pi_getLL('no_email','no_email');
			}

			// Avoid bad characters in database request
			$quiz_taker_name = $GLOBALS['TYPO3_DB']->quoteStr($quizData["name"], $tableAnswers); //addslashes($quizData["name"]);
			$quiz_taker_email  = $GLOBALS['TYPO3_DB']->quoteStr($quizData["email"], $tableAnswers); //addslashes($quizData["email"]);
			$quiz_taker_homepage = $GLOBALS['TYPO3_DB']->quoteStr($quizData["homepage"], $tableAnswers); //addslashes($quizData["homepage"]);
			
			$markerArray["###REAL_NAME###"] = $quiz_taker_name;
			$markerArray["###REAL_EMAIL###"] = $quiz_taker_email;
			$markerArray["###REAL_HOMEPAGE###"] = $quiz_taker_homepage;
			$markerArray["###RESULT_FOR###"] = $this->pi_getLL('result_for','result_for');
			$markerArray["###THANK_YOU###"] = $this->pi_getLL('thank_you','thank_you');
			$markerArray["###RES_QUESTION_POINTS###"] = $this->pi_getLL('result_question_points','result_question_points');
			if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] ) {
				$markerArray["###P1###"] = $this->pi_getLL('p1','p1');
				$markerArray["###P2###"] = $this->pi_getLL('p2','p2');
			} else {
				$markerArray["###P1###"] = '';
				$markerArray["###P2###"] = '';
			}
			$markerArray["###VAR_QUESTIONS###"] = $helperObj->getQuestionsNo();
			if ($whereAnswered)
				$markerArray["###VAR_QUESTION###"] = $helperObj->getQuestionNo($whereAnswered);
			else
				$markerArray["###VAR_QUESTION###"] = $helperObj->getQuestionNo('-');
				
			if ( $quiz_taker_email==$this->pi_getLL('no_email','no_email') ) {
				$quiz_taker_email='';
			}
			if ( $quiz_taker_homepage==$this->pi_getLL('no_homepage','no_homepage') ) {
				$quiz_taker_homepage='';
			}
			
			
			// Begin HTML output
			if ( $this->conf['isPoll'] ) {
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_POLL_SUBMITED###");	// Output thank you
				$markerArrayP["###REF_INTRODUCTION###"] = $this->cObj->substituteMarkerArray($template, $markerArray);  // instead $content
			} else if ( $this->conf['userData.']['showAtAnswer'] ) { // !$this->conf['dontShowUserData'] && !$this->conf['dontShowUserResult'] ) {	nicht mehr seit 0.4.0
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_USER_SUBMITED###"); // Output the user name
				$markerArrayP["###REF_INTRODUCTION###"] = $this->cObj->substituteMarkerArray($template, $markerArray);	// instead $content
			}
			
			$template_qr = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QRESULT###"); // full template
			$template_answer = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR###");
			$template_okok = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR_ANSW###");
			$template_oknot = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR_NOTANSW###");
			$template_notok = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_NOTCORR_ANSW###");
			$template_notnot = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_NOTCORR_NOTANSW###");
			$template_qr_points = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_POINTS###");
			$template_expl = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_EXPLANATION###");
			$template_delimiter = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_DELIMITER###");
			$template_image_begin = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_IMAGE_BEGIN###");
			$template_image_end = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_IMAGE_END###");

			// Get questions from the database
			$questionsArray = array();
			$questionNumber = 0;
			$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
					$tableQuestions,
					'pid='.$thePID.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableQuestions),
					'',
					'',
					'');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
			if ($rows>0) {
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){ 
					$questionNumber = $row['uid'];			// save the uid for each question
					$questionsArray[$questionNumber] = $row; 	// save each question
				}
			}
			$GLOBALS['TYPO3_DB']->sql_free_result($res5); 
			
			// Get the answers from the user
			$answerArray = array();
			$questionNumber = 1;
			while( $quizData['uid'.$questionNumber] ) {
				$answerArray[$questionNumber] = $quizData['uid'.$questionNumber];
				$questionNumber++;
			}
			$maxQuestions = $questionNumber-1;

			$points=0;				// points from the user (quiz taker)
			$maxPoints=0;			// maximum points reachable per page
			$maxTotal=0;			// maximum total points reachable
			$percent=0;				// 100 * reached points / total points
			$overallMaximum = 0;	// overall points of all questions
			$overallPercent = 0;	// overall percent
			$questionUID=0;			// uid of a question
			$answered='';			// uids of answered questions
			$skipped='';			// uids of skipped questions
			$skippedCount = 0;		// no. of skipped questions at this page
			$imgTSConfig = Array();	// image values
			if (is_array($this->conf['jokers.']))
				$halvePoints = $this->conf['jokers.']['halvePoints'];
			else
				$halvePoints = 0;
			
			// Old questions and answers
			for( $questionNumber=1; $questionNumber < $maxQuestions+1; $questionNumber++ ) {
				$questionUID = $answerArray[$questionNumber]; 
				$row = $questionsArray[$questionUID];
				
				if ($this->conf['isPoll']) {	// link to the result page    && $this->conf['showPollResultLink']
					$urlParameters = array("tx_myquizpoll_pi1[cmd]" => "list", "tx_myquizpoll_pi1[qid]" => $questionUID, "no_cache" => "1");
					$markerArray["###POLLRESULT_URL###"] = $this->pi_linkToPage($this->pi_getLL('poll_url','poll_url'), $listPID, $target = '', $urlParameters);
				} else if ($quizData['answer'.$questionNumber]==-1) {
					$skipped.=",".$questionUID;
					$skippedCount++;
					continue;
				}

				$answerPointsBool = false;
				$answered.=",".$questionUID;		// nach unten geschoben...
				$questionPoints=0;
				$maxQuestionPoints=0;
				$markerArray["###VAR_QUESTION###"]++;
				
				// Output the result/explanations
				if ( !($this->conf['dontShowCorrectAnswers'] && $this->conf['dontShowPoints']) || $this->conf['isPoll'] ) {
				
					if ($row['image'] && (substr_count($template_qr, 'REF_QUESTION_IMAGE_BEGIN')>0)) {
						$imgTSConfig['file'] = 'uploads/tx_myquizpoll/'.$row['image']; //The image field name
						$imgTSConfig['altText'] = $row["alt_text"];
						$imgTSConfig['titleText'] = $row["alt_text"];
						if (is_array($this->conf['images.'])) {
							$imgTSConfig['file.']['maxW'] = $this->conf['images.']['maxW'];
							$imgTSConfig['file.']['maxH'] = $this->conf['images.']['maxH'];
						}
						//$this->conf["image."]["file"] = 'uploads/tx_myquizpoll/'.($row['image']); //The image field name
						$markerArray["###VAR_QUESTION_IMAGE###"] = $this->cObj->IMAGE($imgTSConfig);	// statt $this->conf["image."]
						$markerArray["###REF_QUESTION_IMAGE_BEGIN###"] = $this->cObj->substituteMarkerArray($template_image_begin, $markerArray);
						$markerArray["###REF_QUESTION_IMAGE_END###"] = $template_image_end;
					} else {
						$markerArray["###REF_QUESTION_IMAGE_BEGIN###"] = '';
						$markerArray["###REF_QUESTION_IMAGE_END###"] = '';
					}
					$markerArray["###VAR_QUESTION_TITLE###"] = $row['title'];
					$markerArray["###VAR_QUESTION_NAME###"] = $row['name'];
					$markerArray["###REF_QR_ANSWER_ALL###"] = '';
					$markerArray["###REF_QR_ANSWER_CORR###"] = '';
					$markerArray["###REF_QR_ANSWER_CORR_ANSW###"] = '';
					$markerArray["###REF_QR_ANSWER_CORR_NOTANSW###"] = '';
					$markerArray["###REF_QR_ANSWER_NOTCORR_ANSW###"] = '';
					$markerArray["###REF_QR_ANSWER_NOTCORR_NOTANSW###"] = '';
					$markerArray["###REF_QR_POINTS###"] = '';
					$markerArray["###VAR_QUESTION_ANSWER###"] = '';
					$markerArray["###VAR_ANSWER_POINTS###"] = '';
					$markerArray["###VAR_QUESTION_POINTS###"] = '';
					$markerArray["###VAR_MAX_QUESTION_POINTS###"] = '';
					$markerArray["###REF_QR_EXPLANATION###"] = '';
					$markerArray["###REF_DELIMITER###"] = '';
					if ( $this->conf['dontShowPoints'] )
						$markerArray["###NO_POINTS###"] = '';
					else
						$markerArray["###NO_POINTS###"] = '0';
					
					if ( !$this->conf['isPoll'] ) {
						for ($currentValue=1; $currentValue <= $this->answerChoiceMax; $currentValue++) {
							if (intval($row['points'.$currentValue])>0 ) {
								$answerPointsBool = true;
								break;
							}
						}
					}
				
					if (is_array($this->conf['myVars.']['questions.'])) {
						foreach($this->conf['myVars.']['questions.'] as $key => $value) {
							$myQArray = split(',', $value);
							$myKey = ($questionNumber-1)%count($myQArray);
							$markerArray["###MY_".strtoupper($key)."###"] = $myQArray[$myKey];
						}
					}
					
					for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {
						
						if ($row['answer'.$answerNumber]) {	// was a answer set in the backend?
							
							$selected=0;	// was the answer selected by the quiz taker?
							$tempAnswer = ''; // text for answer $answerNumber
							if (is_array($this->conf['myVars.']['answers.'])) {						// custom variables
								foreach($this->conf['myVars.']['answers.'] as $key => $value) {
									$myAArray = split(',', $value);
									$myKey = ($answerNumber-1)%count($myAArray);
									$markerArray["###MY_".strtoupper($key)."###"] = $myAArray[$myKey];
								}
							}
							
							if ( !$this->conf['isPoll'] ) {	// show correct answers. Bug fixed: dontShowCorrectAnswers doesnt matter here
								if ( !$this->conf['dontShowCorrectAnswers'] )
									$markerArray["###VAR_QUESTION_ANSWER###"] = $row['answer'.$answerNumber];
								
								$answerPoints = 0;		// answer points from the DB
								if ( !$this->conf['dontShowPoints'] ) {
									if ($answerPointsBool) { 		// hier interessiert es nicht, ob eine Antwort als korrekt markiert wurde!
										$answerPoints = intval($row['points'.$answerNumber]);
										if ($answerPoints > 0)
											$row['correct'.$answerNumber] = true;		// ACHTUNG: falls Punkte zu einer Antwort gesetzt sind, dann wird die Antwort als RICHTIG bewertet!
									} else {
										$answerPoints = intval($row['points']);
									}
									if ($row['correct'.$answerNumber] || $row['qtype']==3) {
										if (!$answerPointsBool || $row['qtype'] == 0 || $row['qtype'] == 3)
											$maxQuestionPoints+=$answerPoints;
										else if ($answerPoints > $maxQuestionPoints)
											$maxQuestionPoints=$answerPoints;	// bei punkten pro antwort
									}
									$markerArray["###VAR_ANSWER_POINTS###"] = $answerPoints;
								}
								
								if ($quizData['answer'.$questionNumber.'_'.$answerNumber]!='') {	// type 0
									$selected=$answerNumber; 
								} else if ($row['qtype']>0 && $row['qtype']<3 && $quizData['answer'.$questionNumber]==$answerNumber) {
									$selected=$answerNumber;
								} else if ($row['qtype']==3 && $quizData['answer'.$questionNumber]!='') {	// type 3
									$selected=$answerNumber;			// sollte 1 sein
								}
							}
							
							$wrongText = 0;		// wrong text input?
							
							if ($this->conf['isPoll']) { 
								$points=$quizData['answer'.$questionNumber];						// points = SELECTED ANSWER !!!
							} else if ($selected>0 && ( ($row['qtype']==3 && strtolower($row['answer'.$answerNumber])==strtolower($quizData['answer'.$questionNumber])) ||
														($row['qtype']< 3 && $row['correct'.$answerNumber]) )) {
								$questionPoints=$questionPoints+$answerPoints;	// $row['points']; geaendert am 16.9.2009
								if ( !$this->conf['dontShowCorrectAnswers'] ) {
									$tempAnswer = $this->cObj->substituteMarkerArray($template_okok, $markerArray);
									$markerArray["###REF_QR_ANSWER_CORR_ANSW###"] .= $tempAnswer;
								}
							} else if ($selected>0) {
								if ($this->conf['noNegativePoints']!=2)
									$questionPoints=$questionPoints-$answerPoints;	// $row['points']; geaendert am 16.9.2009
								if ( !$this->conf['dontShowCorrectAnswers'] ) {		 // { added 8.8.09
									if ($row['qtype']==3) {		// since 0.1.8: falsche antwort und richtige antwort ausgeben
										$tempAnswer = $this->cObj->substituteMarkerArray($template_oknot, $markerArray);
										$markerArray["###REF_QR_ANSWER_CORR_NOTANSW###"] .= $tempAnswer;
										$markerArray["###VAR_QUESTION_ANSWER###"] = $quizData['answer'.$questionNumber];										
									}
									$tempAnswer2 = $this->cObj->substituteMarkerArray($template_notok, $markerArray);
									$markerArray["###REF_QR_ANSWER_NOTCORR_ANSW###"] .= $tempAnswer2;
									$tempAnswer .= $tempAnswer2;	// hier gibt es 2 antworten !!!
								}
								if ($row['qtype']==3) $wrongText=1;		// for statistics: a2 statt a1 bei falscher antwort
							} else if ($row['correct'.$answerNumber] && !$this->conf['dontShowCorrectAnswers']) {
								$tempAnswer = $this->cObj->substituteMarkerArray($template_oknot, $markerArray);
								$markerArray["###REF_QR_ANSWER_CORR_NOTANSW###"] .= $tempAnswer;
								if ($row['qtype']==3) {
									$wrongText=1;		// for statistics: a2 statt a1 bei falscher antwort
									$selected=2;		// statistics: no answer = false answer !
								}
							} else if ( !$this->conf['dontShowCorrectAnswers'] ) {
								$tempAnswer = $this->cObj->substituteMarkerArray($template_notnot, $markerArray);
								$markerArray["###REF_QR_ANSWER_NOTCORR_NOTANSW###"] .= $tempAnswer;
							}
							if (!$this->conf['isPoll'] && !$this->conf['dontShowCorrectAnswers']) {
								$markerArray["###REF_QR_ANSWER_ALL###"] .= $tempAnswer;		// all answers in correct order
								if ($row['correct'.$answerNumber] || $row['qtype']==3) {	// all correct answers
									$markerArray["###REF_QR_ANSWER_CORR###"] .= $this->cObj->substituteMarkerArray($template_answer, $markerArray);
								}
							}
							
							if ($this->conf['advancedStatistics'] && !$this->conf['isPoll']) {			// for more statistics
								$statisticsArray[$questionUID]['a'.($answerNumber+$wrongText)] = ($selected>0) ? 1 : 0;
								if ($row['qtype']==3 && $quizData['answer'.$questionNumber]) {
									$statisticsArray[$questionUID]['text'] = $GLOBALS['TYPO3_DB']->quoteStr($quizData['answer'.$questionNumber], $tableRelation);
								} else {
									$statisticsArray[$questionUID]['text'] = '';
								}
							}
							
						}
					}
					
					if (!$this->conf['dontShowPoints'] && !$this->conf['isPoll']) {		// Bug fixed: dontShowCorrectAnswers doesnt matter here
						if ($questionPoints<0 && $this->conf['noNegativePoints'])
							$questionPoints=0;
						if ($questionPoints>0 && $halvePoints && ($quizData["joker1"] || $quizData["joker2"] || $quizData["joker3"]))
							$questionPoints = intval($questionPoints/2);
						$points+=$questionPoints;
						$maxPoints+=$maxQuestionPoints;
						
						if ($this->conf['advancedStatistics'])
							$statisticsArray[$questionUID]['points'] = $questionPoints;
					} else if ($this->conf['advancedStatistics'])
							$statisticsArray[$questionUID]['points'] = 0;
					
					if (!$this->conf['dontShowCorrectAnswers'] && !$this->conf['isPoll']) {
						if (!$this->conf['dontShowPoints']) {
							$markerArray["###VAR_QUESTION_POINTS###"] = $questionPoints;
							$markerArray["###VAR_MAX_QUESTION_POINTS###"] = $maxQuestionPoints;
							$markerArray["###REF_QR_POINTS###"] = $this->cObj->substituteMarkerArray($template_qr_points, $markerArray);
						}
						
						if ( $row['explanation']!='' ) {	// Explanation
							$markerArray["###VAR_EXPLANATION###"] = $row['explanation'];
							$markerArray["###REF_QR_EXPLANATION###"] = $this->cObj->substituteMarkerArray($template_expl, $markerArray);
						}
					
						$markerArray["###REF_DELIMITER###"] = $this->cObj->substituteMarkerArray($template_delimiter, $markerArray);
					}
				}
				if (!$this->conf['dontShowCorrectAnswers'] && !$this->conf['isPoll'])	// bug fixed: points dont even matter
					$markerArrayP["###REF_QRESULT###"] .= $this->cObj->substituteMarkerArray($template_qr, $markerArray);  // instead of $content
			}
			
			if ($answered) $answered=substr($answered,1);	// now answered questions (UIDs)
			if ($skipped) $skipped=substr($skipped,1);	// now skipped questions (UIDs)
			
			$doUpdate=0;					// insert or update?
			$pointsTotal=$points;			// total points, reached
			$maxTotal = $maxPoints;			// total points, maximum
			/*
			if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] ) {		// (vorläufige) Werte sichern
				$markerArray["###VAR_TOTAL_POINTS###"] = $pointsTotal;
				$markerArray["###VAR_TMAX_POINTS###"] = $maxTotal;
				$markerArray["###VAR_PERCENT###"] = intval(100 * $pointsTotal / $maxTotal);
			}
			*/
			if ( $this->conf['isPoll'] && !$this->conf['dontShowPollResult'] ) {
				$quizData["cmd"] = 'list';
			}
			else
			if ($this->conf['pageQuestions'] > 0 && !$this->conf['isPoll']) {	// more questions aviable?
			
				if (!$this->conf['showAnswersSeparate'])
					$quizData["cmd"] = '';						// show more/next questions!
				// Seek for old answered questions
				if ($quizData["qtuid"]) {
					$uid = intval($quizData["qtuid"]);
					$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('qids, sids, p_or_a, p_max, joker1,joker2,joker3',
						$tableAnswers,
						'uid='.$uid.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableAnswers),
						'',
						'',
						'');
					$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
					if ($rows>0) {							// DB entry found for current user?
						$fetchedRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5);
						$answeredOld = $fetchedRow['qids'];
						$skippedOld = $fetchedRow['sids'];
						$pointsOld = $fetchedRow['p_or_a'];
						$maxPointsOld = $fetchedRow['p_max'];
						$joker1 =  $fetchedRow['joker1'];
						$joker2 =  $fetchedRow['joker2'];
						$joker3 =  $fetchedRow['joker3'];
						if (!$answered) {				// all questions skipped  # Fall 1: bisher nur geskipped
							$answered = $answeredOld;	// all answered questions
							if ($skippedOld && $skipped) 
								$skipped .= ','.$skippedOld; 
							else if ($skippedOld)
								$skipped = $skippedOld;				
							$pointsTotal = $pointsOld;	// total points
							$maxTotal = $maxPointsOld;
							//if ($answeredOld) $doUpdate=1;
							$doUpdate = 3;
						} else if (stristr(','.$answeredOld.',', ','.$answered.',')) {  // Fall 2: somebody tries to cheat! Bug fixed: ',' matters
							$answered = $answeredOld;	// all answered questions
							$skipped = $skippedOld;		// all skipped questions
							$pointsTotal = $pointsOld;	// total points
							$maxTotal = $maxPointsOld;
							$doUpdate = 2;
							$markerArray["###CHEATING###"] = $this->pi_getLL('cheating','cheating');
							$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_CHEATING###");
							$markerArrayP["###REF_RES_ERRORS###"] .= $this->cObj->substituteMarkerArray($template, $markerArray);	// instead $content
						} else if ($answeredOld) {			// Fall 3: man hat schon was beantwortet
							$answered .= ','.$answeredOld;	// all answered questions
							if ($skippedOld && $skipped) 
								$skipped .= ','.$skippedOld; 
							else if ($skippedOld)
								$skipped = $skippedOld;
							$pointsTotal = $points + $pointsOld;	// total points
							//$maxTotal = $maxPoints;
							if ($maxPointsOld > 0) $maxTotal = $maxTotal + $maxPointsOld;
							$doUpdate = 1;
						} else if ($skippedOld) {		// Fall 4: skipped, dann beantwortet
							if ($skippedOld && $skipped) 
								$skipped .= ','.$skippedOld; 
							else 
								$skipped = $skippedOld;
							$pointsTotal = $points;	// total points
							$doUpdate = 1;
						}
					}
				}
				$whereAnswered = '';
				if ($answered) $whereAnswered = ' AND uid NOT IN ('.$answered.')';	// exclude answered questions next time
				$whereSkipped = '';
				if ($skipped) $whereSkipped = ' AND uid NOT IN ('.$skipped.')';	// exclude skipped questions next time
				
				if ($skippedCount > 0) {
					$markerArray["###VAR_NO###"] = $skippedCount;
					$markerArray["###SKIPPED###"] = $this->pi_getLL('skipped','skipped');
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_SKIPPED###");
					$markerArrayP["###REF_SKIPPED###"] = $this->cObj->substituteMarkerArray($template, $markerArray);	// instead $content
				}
				
			} else if ( $this->conf['showHighscore'] ) {
				$quizData["cmd"] = 'score';			// otherwise decide this later
			}

			if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] ) {	// Total points yet. && !$this->conf['dontShowCorrectAnswers'] ??
				$markerArray["###RESULT_POINTS###"] = $this->pi_getLL('result_points','result_points');
				$markerArray["###TOTAL_POINTS###"] = $this->pi_getLL('total_points','total_points');
				$markerArray["###SO_FAR_REACHED1###"] = $this->pi_getLL('so_far_reached1','so_far_reached1');
				$markerArray["###SO_FAR_REACHED2###"] = $this->pi_getLL('so_far_reached2','so_far_reached2');
				$markerArray["###VAR_RESULT_POINTS###"] = $points;
				$markerArray["###VAR_MAX_POINTS###"] = $maxPoints;
				$markerArray["###VAR_MISSING_POINTS###"] = $maxPoints - $points;
				$markerArray["###VAR_TOTAL_POINTS###"] = $pointsTotal;
				$markerArray["###VAR_TMAX_POINTS###"] = $maxTotal;
				$markerArray["###VAR_TMISSING_POINTS###"] = $maxTotal - $pointsTotal;
				if ($maxTotal>0)
					$percent = intval(round(100 * $pointsTotal / $maxTotal));
				$markerArray["###VAR_PERCENT###"] = $percent;
				$overallMaximum = $markerArray["###VAR_OMAX_POINTS###"];
				if ($overallMaximum) {
					$overallPercent = 100 * $pointsTotal / $overallMaximum;
					$markerArray["###VAR_OVERALL_PERCENT###"] = intval(round($overallPercent));
					//$markerArray["###VAR_OMAX_POINTS###"] = $overallMaximum;
				}
				
				if ($doUpdate == 0) {
					$overallMaximum = $helperObj->getQuestionsMaxPoints();		// maximum points of all questions
					if ($overallMaximum > 0)
						$overallPercent = 100 * $markerArray["###VAR_TOTAL_POINTS###"] / $overallMaximum;
					$markerArray["###VAR_OVERALL_PERCENT###"] = intval(round($overallPercent));
					$markerArray["###VAR_OMAX_POINTS###"] = $overallMaximum;

					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_RESULT_POINTS###");
				} else {
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_RESULT_POINTS_TOTAL###");
				}
				$markerArrayP["###REF_QPOINTS###"] = $this->cObj->substituteMarkerArray($template, $markerArray);  // instead $content
			}
			
			
			if ($points == '')
				$points = 0;
			if ($pointsTotal == '')
				$pointsTotal = 0;
				
			if ($doUpdate==0 && ($points>0 || !$this->conf['isPoll'])) {
				// get highest sorting-id
				$nextSorting = 0;
				$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('max(sorting)',
					$tableAnswers,
					'pid='.$thePID.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableAnswers),
					'',
					'',
					'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
				if ($rows>0) {
					while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){ 
						$nextSorting = $row['max(sorting)']+1;
					}
				}
				
				//if (!$this->conf['isPoll'] && !$this->conf['dontShowPoints']) {
					//$overallMaximum = $this->getTotalMax($tableQuestions, $thePID);		// maximum points of all questions
					// von hier etwas höher kopiert
				//}
				
				//Jokers
				$joker1 = intval($quizData["joker1"]);
				$joker2 = intval($quizData["joker2"]);
				$joker3 = intval($quizData["joker3"]);
				
				// Insert new results into database
				$timestamp = time();
				$firsttime = intval($quizData["time"]);
				$insert = array('pid' => $thePID,
								'tstamp' => $timestamp,
								'crdate' => $timestamp,
								'sorting' => $nextSorting,
								'name' => $quiz_taker_name,
								'email' => $quiz_taker_email,
								'homepage' => $quiz_taker_homepage,
								'ip' => $quiz_taker_ip_address,
								'p_or_a' => $points,
								'p_max' => $maxPoints,
								'percent' => $percent,
								'o_max' => $overallMaximum,
								'o_percent' => $overallPercent,
								'qids' => $answered,
								'sids' => $skipped,
								'joker1' => $joker1,
								'joker2' => $joker2,
								'joker3' => $joker3,
								'firsttime' => $firsttime,
								'lasttime' => $timestamp,
								'sys_language_uid' => $this->lang);
				$success = $GLOBALS['TYPO3_DB']->exec_INSERTquery($tableAnswers, $insert);
				if($success){
					$quizData["qtuid"] = $GLOBALS['TYPO3_DB']->sql_insert_id();		
					if ( $this->conf['useCookiesInDays']>0 ) {	// save quiz takers UID as cookie?
						setcookie("myquizpoll".$thePID, $quizData["qtuid"], time()+(3600*24*$this->conf['useCookiesInDays']));  /* cookie for x days */
					}
					$helperObj->setFirstTime($quizData["qtuid"], $firsttime);
				} else {
					$content.="<p>MySQL Insert-Error :-(</p>";
				}
			} else if ($doUpdate==1) {
				// update current user entry
				$uid=intval($quizData["qtuid"]);
				$timestamp = time();
				$update = array('tstamp' => $timestamp,
								'name' => $quiz_taker_name,
								'email' => $quiz_taker_email,
								'homepage' => $quiz_taker_homepage,
								'p_or_a' => $pointsTotal,
								'p_max' => $maxTotal,
								'percent' => $percent,
								'o_percent' => $overallPercent,
								'qids' => $answered,
								'sids' => $skipped,
								'lasttime' => $timestamp);
				$success = $GLOBALS['TYPO3_DB']->exec_UPDATEquery($tableAnswers, 'uid='.$uid.' AND sys_language_uid='.$this->lang, $update);
				if(!$success){
					$content.="<p>MySQL Update-Error :-(</p>";
				}
			} else if ($doUpdate==3) {
				// update current skipped entry (only skipped questions?!?!)
				$uid=intval($quizData["qtuid"]);
				$timestamp = time();
				$update = array('tstamp' => $timestamp,
								'sids' => $skipped,
								'lasttime' => $timestamp);
				$success = $GLOBALS['TYPO3_DB']->exec_UPDATEquery($tableAnswers, 'uid='.$uid.' AND sys_language_uid='.$this->lang, $update);
				if(!$success){
					$content.="<p>MySQL Update-Error :-(</p>";
				}
			}
			
			$markerArray["###QTUID###"] = $quizData["qtuid"];
			
			if ($this->conf['advancedStatistics'] && $doUpdate<2) {
				// write advanced Statistics to database
				$uid=intval($quizData["qtuid"]);
				$timestamp = time();
				if (is_array($statisticsArray)) {
					foreach ($statisticsArray as $type => $element) {
						$insert = array('pid' => $thePID,
										'tstamp' => $timestamp,
										'crdate' => $timestamp,
										'deleted' => 0,
										'user_id' => 1,
										'question_id' => 1,
										'textinput' => $element['text'],
										'checked1' => $element['a1'],
										'checked2' => $element['a2'],
										'checked3' => $element['a3'],
										'checked4' => $element['a4'],
										'checked5' => $element['a5'],
										'points' => $element['points'],
										'sys_language_uid' => $this->lang);
						$success = $GLOBALS['TYPO3_DB']->exec_INSERTquery($tableRelation, $insert);
						if($success){
							$statID = $GLOBALS['TYPO3_DB']->sql_insert_id();		
						} else {
							$content.="<p>MySQL Insert-Error xyz</p>";
							$statID=0;
						}
						
						$insert = array('uid_local' => $statID,
										'uid_foreign' => $uid,
										'sorting' => 1);
						$success = $GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_myquizpoll_relation_user_id_mm', $insert);
						if(!$success)
							$content.="<p>MySQL Insert-Error mm1.</p>";
						$insert = array('uid_local' => $statID,
										'uid_foreign' => $type,
										'sorting' => 1);
						$success = $GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_myquizpoll_relation_question_id_mm', $insert);
						if(!$success)
							$content.="<p>MySQL Insert-Error mm2.</p>";
					}
				}
			}
			
			if (!$this->conf['pageQuestions'] && !$this->conf['isPoll']) {
				$finalPage = true;
			}
			$answerPage = true;
		}
		
		
		if( $this->conf['finishedMinPercent'] && $this->conf['pageQuestions']>0 && $markerArray["###VAR_TOTAL_POINTS###"]!=='' &&
		  (!$this->conf['showAnswersSeparate'] || !$quizData["cmd"]) && $no_rights==0 ) {  /* ***************************************************** */
			/*
			 * Display positive cancel page: quiz taker has reached finishedMinPercent percent???
			 */

			//$overallMaximum = $this->getTotalMax($tableQuestions, $thePID);		// maximum points of all questions
			if ($markerArray["###VAR_OMAX_POINTS###"])
				$myPercent = 100 * $markerArray["###VAR_TOTAL_POINTS###"] / $markerArray["###VAR_OMAX_POINTS###"];
			else
				$myPercent = 0;
			$uidP = 0;
			$finishedMinPercent = $this->conf['finishedMinPercent'];
			if (strpos($finishedMinPercent, ':') !== false) {
				list($finishedMinPercent, $uidP) = split(":", $finishedMinPercent);
			}
			if (intval($finishedMinPercent) <= $myPercent) {		// do we have enough points???
				if ($uidP)		// redirect to a URL with that UID?
					header( 'Location: '.t3lib_div::locationHeaderUrl($this->pi_getPageLink($uidP)) );
				$markerArray["###REACHED1###"] = $this->pi_getLL('reached1','reached1');
				$markerArray["###REACHED2###"] = $this->pi_getLL('reached2','reached2');
				$markerArray["###SO_FAR_REACHED1###"] = $this->pi_getLL('so_far_reached1','so_far_reached1');
				$markerArray["###SO_FAR_REACHED2###"] = $this->pi_getLL('so_far_reached2','so_far_reached2');
				//$markerArray["###VAR_OVERALL_PERCENT###"] = intval($myPercent);
				//$markerArray["###VAR_OMAX_POINTS###"] = $overallMaximum;
				
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_FINISHEDMINPERCENT###");
				if ($template == '')	// if it is not in the template
					$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_QUIZ_FINISHEDMINPERCENT###");
				$content .= $this->cObj->substituteMarkerArray($template, $markerArray);			// sonderfall !!!!!!!!!
				
				$answerPage = false;
				if ( $this->conf['showHighscore'] ) {
					$quizData["cmd"] = 'score';		// show highscore
				} else {
					$quizData["cmd"] = 'exit';		// display no more questions
				}
			}
		}
		
		if( $this->conf['cancelWhenWrong'] && $this->conf['pageQuestions']>0 && ($markerArray["###VAR_TOTAL_POINTS###"]!=='') &&
		  (!$this->conf['showAnswersSeparate'] || !$quizData["cmd"]) && $no_rights==0 ) {  /* ***************************************************** */
			/*
			 * Display negative cancel page: quiz taker has given a wrong answer???
			 */
			if ($markerArray["###VAR_TOTAL_POINTS###"] < $markerArray["###VAR_TMAX_POINTS###"]) {
				$markerArray["###REACHED1###"] = $this->pi_getLL('reached1','reached1');
				$markerArray["###REACHED2###"] = $this->pi_getLL('reached2','reached2');
				$markerArray["###SO_FAR_REACHED1###"] = $this->pi_getLL('so_far_reached1','so_far_reached1');
				$markerArray["###SO_FAR_REACHED2###"] = $this->pi_getLL('so_far_reached2','so_far_reached2');
				$markerArray["###QUIZ_END###"] = $this->pi_getLL('quiz_end','quiz_end');
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_END###");
				if ($template == '')	// if it is not in the template
					$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_QUIZ_END###");
				$content .= $this->cObj->substituteMarkerArray($template, $markerArray);			// sonderfall !!!
				
				$answerPage = false;		// show no answers
				
				if ( $this->conf['finalWhenCancel'] ) {
					$noQuestions = true;
				} else {
					if ( $this->conf['showHighscore'] ) {
						$quizData["cmd"] = 'score';		// show highscore
					} else {
						$quizData["cmd"] = 'exit';		// display no more questions
					}
					$no_rights = 1;					// cancel all				
				}
			}
		}
		
		
		// Pre-fill quiz taker name and email if FE user logged in
		if ($GLOBALS['TSFE']->loginUser) {
			if (!$quizData["name"]) { $quizData["name"] = $GLOBALS['TSFE']->fe_user->user['name']; }
			if (!$quizData["email"]) { $quizData["email"] = $GLOBALS['TSFE']->fe_user->user['email']; }
			if (!$quizData["homepage"]) { $quizData["homepage"] = $GLOBALS['TSFE']->fe_user->user['www']; }
		}
		if ($quizData["name"]) {
			$markerArray["###DEFAULT_NAME###"] = $quizData["name"];
		} else {
			$markerArray["###DEFAULT_NAME###"] = $this->pi_getLL('no_name','no_name');
		}
		if ($quizData["email"]) {
			$markerArray["###DEFAULT_EMAIL###"] = $quizData["email"];
		} else {
			$markerArray["###DEFAULT_EMAIL###"] = $this->pi_getLL('no_email','no_email');
		}
		if ($quizData["homepage"]) {
			$markerArray["###DEFAULT_HOMEPAGE###"] = $quizData["homepage"];
		} else {
			$markerArray["###DEFAULT_HOMEPAGE###"] = $this->pi_getLL('no_homepage','no_homepage');
		}
		
		
		if( $quizData["cmd"] == '' && $no_rights==0 ) {           /* ***************************************************** */
			/*
			 * Display initial page: questions and quiz taker name fields
			 */
			
			if (!$noQuestions) {
				// Order questions by & and limit to
				$sortBy = 'sorting';
				$limitTo = '';
				if ( $this->conf['sortBy'] ) {
					switch ($this->conf['sortBy']) {
						case "sorting": $sortBy = "sorting"; break;
						case "uid": $sortBy = "uid"; break;
						case "title": $sortBy = "title"; break;
						default: $sortBy = "sorting"; break;
					}
				}
				// Limit questions?
				if ( $this->conf['pageQuestions']>0 && $this->conf['sortBy']!='random' ) {
					$limitTo = $this->conf['pageQuestions'];
				}
				
				// Get questions from the database    
				$questionsArray = array();
				$questionNumber = 0;
				$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
						$tableQuestions,
						'pid='.$thePID.$whereAnswered.$whereSkipped.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableQuestions),
						'',
						$sortBy,
						$limitTo);
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
				if (!$rows) {		// now ignore the skipped questions
					$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
						$tableQuestions,
						'pid='.$thePID.$whereAnswered.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableQuestions),
						'',
						$sortBy,
						$limitTo);
					$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
				}
				if ($rows>0) {
					while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){ 
						$questionNumber++;
						$questionsArray[$questionNumber] = $row;
					}
				}
				
				$numOfQuestions = $questionNumber;				// real questions
				$maxQuestions = $this->conf['pageQuestions'];	// should be questions
				
				if ($this->conf['isPoll']) {
					$maxQuestions = 1;					// only max. 1 poll-question
				} else if ( !$maxQuestions ) {
					$maxQuestions = $numOfQuestions; 
				} else if( $numOfQuestions < $maxQuestions ) { 
					$maxQuestions = $numOfQuestions; // no. of maximum question = no. of questions in the DB 
				}
			
				if ( ($numOfQuestions > 0) and ($this->conf['sortBy']=='random') ) {		// any questions out there???	Random questions???
					$randomQuestionsArray = array();
					$questionNumber = 0;
					// Not very fast random method
					while( $questionNumber < $maxQuestions ) {
						$random = mt_rand(1,$numOfQuestions);
						$randomQuestionsArray[$questionNumber+1] = $questionsArray[$random];
						$duplicate = 0;
						for($i=1 ; $i < $questionNumber+1; $i++) {
							if( $randomQuestionsArray[$questionNumber+1]['uid'] == $randomQuestionsArray[$i]['uid'] ) {
								$duplicate = 1 ;
							}
						}
						if( !$duplicate ) { $questionNumber++ ; }
					}
					// rearange questions Array
					for( $questionNumber=1; $questionNumber < $maxQuestions+1; $questionNumber++ ) {
						$questionsArray[$questionNumber] = $randomQuestionsArray[$questionNumber];
					}
				}
				
				if ($this->conf['finishAfterQuestions']) {		// finish after X questions?
					$numOfQuestions = intval($this->conf['finishAfterQuestions']) - $helperObj->getQuestionNo($whereAnswered);
					if( $numOfQuestions < $maxQuestions ) { 
						$maxQuestions = $numOfQuestions; // no. of maximum question = no. of questions in the DB 
					}
				}
			} else {
				$numOfQuestions = 0;
			}
			
			if ( $numOfQuestions > 0 ) {		// any questions out there???
				
				// Start des Output
//				$content .= "<form action=\"".$this->pi_getPageLink($GLOBALS['TSFE']->id)."\" method=\"post\" name=\"myquiz\">\n";  // old, deprecated since 0.1.8
				$lastUID = 0;		// remember the last question ID
				$imgTSConfig = array();
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION###");
				$template_image_begin = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_IMAGE_BEGIN###");
				$template_image_end = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_IMAGE_END###");
				$template_answer = $this->cObj->getSubpart($template, "###TEMPLATE_QUESTION_ANSWER###");
				$template_delimiter = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_DELIMITER###");
				
				if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] ) {
					$markerArray["###P1###"] = $this->pi_getLL('p1','p1');
					$markerArray["###P2###"] = $this->pi_getLL('p2','p2');
				} else {
					$markerArray["###P1###"] = '';
					$markerArray["###P2###"] = '';
				}
				$markerArray["###VAR_QUESTIONS###"] = $helperObj->getQuestionsNo();
				$markerArray["###VAR_QUESTION###"] = $helperObj->getQuestionNo($whereAnswered);
				
				// Questions and answers
				for ($questionNumber=1; $questionNumber < $maxQuestions+1; $questionNumber++) {
					$row = $questionsArray[$questionNumber];
					
					$answerPointsBool = false;		// gibt es punkte bei einzelnen antworten?
					$markerArray["###VAR_QUESTION###"]++;
					if ($row['image']) {
						$imgTSConfig['file'] = 'uploads/tx_myquizpoll/'.$row['image']; //The image field name
						$imgTSConfig['altText'] = $row["alt_text"];
						$imgTSConfig['titleText'] = $row["alt_text"];
						if (is_array($this->conf['images.'])) {
							$imgTSConfig['file.']['maxW'] = $this->conf['images.']['maxW'];
							$imgTSConfig['file.']['maxH'] = $this->conf['images.']['maxH'];
						}
						//$this->conf["image."]["file"] = 'uploads/tx_myquizpoll/'.($row['image']); //The image field name
						$markerArray["###VAR_QUESTION_IMAGE###"] = $this->cObj->IMAGE($imgTSConfig);	// statt $this->conf["image."]
						$markerArray["###REF_QUESTION_IMAGE_BEGIN###"] = $this->cObj->substituteMarkerArray($template_image_begin, $markerArray);
						$markerArray["###REF_QUESTION_IMAGE_END###"] = $template_image_end;
					} else {
						$markerArray["###REF_QUESTION_IMAGE_BEGIN###"] = '';
						$markerArray["###REF_QUESTION_IMAGE_END###"] = '';
					}
					$markerArray["###VAR_QUESTION_TITLE###"] = $row['title'];
					$markerArray["###VAR_QUESTION_NAME###"] = $row['name'];
					if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] ) {
						$markerArray["###VAR_QUESTION_POINTS###"] = 0;
						if ($markerArray["###VAR_TOTAL_POINTS###"])
							$markerArray["###VAR_NEXT_POINTS###"] = $markerArray["###VAR_TOTAL_POINTS###"];
						else
							$markerArray["###VAR_NEXT_POINTS###"] = 0;
						for ($currentValue=1; $currentValue <= $this->answerChoiceMax; $currentValue++) {
							if (intval($row['points'.$currentValue])>0 ) {
								$answerPointsBool = true;
								break;
							}
						}
						if ($answerPointsBool)
							$markerArray["###VAR_ANSWER_POINTS###"] = $this->pi_getLL('different_number_of','different_number_of');
						else {
							if ($row['qtype'] == 0)
								$markerArray["###VAR_ANSWER_POINTS###"] = $this->pi_getLL('each','each').' '.$row['points'];
							else
								$markerArray["###VAR_ANSWER_POINTS###"] = $row['points'];
						}
					} else {
						$markerArray["###VAR_ANSWER_POINTS###"] = '';
						$markerArray["###VAR_QUESTION_POINTS###"] = '';
						$markerArray["###VAR_NEXT_POINTS###"] = '';
					}
					$markerArray["###REF_QUESTION_ANSWER###"] = '';
					if ($row['qtype'] == 2) {
						$markerArray["###VAR_QUESTION_ANSWER###"] = '<select name="tx_myquizpoll_pi1[answer'.$questionNumber.']" ###MY_SELECT###>'."\n"; //  class="'.$this->prefixId.'-answer"
					} 
					
					if (is_array($this->conf['myVars.']['questions.'])) {
						foreach ($this->conf['myVars.']['questions.'] as $key => $value) {
							$myQArray = split(',', $value);
							$myKey = ($questionNumber-1)%count($myQArray);
							$markerArray["###MY_".strtoupper($key)."###"] = $myQArray[$myKey];
						}
					}
					if (!$markerArray["###MY_SELECT###"])			// we need default values...
						$markerArray["###MY_SELECT###"] = '';
					
					// Jokers
					if ($this->conf['useJokers'] && $this->conf['pageQuestions']==1) {
						$temp_uid = $quizData["qtuid"];
						$markerArrayJ["###JAVASCRIPT###"] = '';
						if (!$temp_uid) $temp_uid=0;
						$markerArrayJ["###JOKER_50###"] = $this->pi_getLL('joker_50','joker_50');
						$markerArrayJ["###JOKER_AUDIENCE###"] = $this->pi_getLL('joker_audience','joker_audience');
						$markerArrayJ["###JOKER_PHONE###"] = $this->pi_getLL('joker_phone','joker_phone');
						if (is_array($this->conf['jokers.']))
							$unlimited = $this->conf['jokers.']['unlimited'];
						else
							$unlimited = 0;
						if ($joker1 && !$unlimited) {
							$markerArrayJ["###JOKER_50_LINK###"] = '';
							$markerArrayJ["###JAVASCRIPT###"] .= "document.getElementById('".$this->prefixId."-joker_50').style.display = 'none';\n";
						} else
							$markerArrayJ["###JOKER_50_LINK###"] = $this->prefixId.'getAjaxData('.$row['uid'].','.$temp_uid.',1,\'joker_50\');';
						if ($joker2 && !$unlimited) {
							$markerArrayJ["###JOKER_AUDIENCE_LINK###"] = '';
							$markerArrayJ["###JAVASCRIPT###"] .= "document.getElementById('".$this->prefixId."-joker_audience').style.display = 'none';\n";
						} else
							$markerArrayJ["###JOKER_AUDIENCE_LINK###"] = $this->prefixId.'getAjaxData('.$row['uid'].','.$temp_uid.',2,\'joker_audience\');';
						if ($joker3 && !$unlimited) {
							$markerArrayJ["###JOKER_PHONE_LINK###"] = '';
							$markerArrayJ["###JAVASCRIPT###"] .= "document.getElementById('".$this->prefixId."-joker_phone').style.display = 'none';\n";
						} else
							$markerArrayJ["###JOKER_PHONE_LINK###"] = $this->prefixId.'getAjaxData('.$row['uid'].','.$temp_uid.',3,\'joker_phone\');';
						
						//if ($markerArrayJ["###JAVASCRIPT###"]) {
						//	$markerArrayJ["###JAVASCRIPT###"] = '<script type="text/javascript">'."\n".$markerArrayJ["###JAVASCRIPT###"]."\n".'</script>';
						//}
						
						$template_jokers = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_JOKERS###");
						$markerArrayP["###REF_JOKERS###"] = $this->cObj->substituteMarkerArray($template_jokers, $markerArrayJ);
					}
					
					// Display answers
					for( $currentValue=1; $currentValue < $this->answerChoiceMax+1; $currentValue++) {
						if( $row['answer'.$currentValue] ) {
							$answer_choice = $this->formatStr($this->local_cObj->stdWrap($row['answer'.$currentValue],$lConf["content_stdWrap."]));
							
							if (is_array($this->conf['myVars.']['answers.']) && ($row['qtype'] != 2 || $currentValue == 1)) {
								foreach($this->conf['myVars.']['answers.'] as $key => $value) {
									$myAArray = split(',', $value);
									$myKey = ($currentValue-1)%count($myAArray);
									$markerArray["###MY_".strtoupper($key)."###"] = $myAArray[$myKey];
								}
							}
							if (!$markerArray["###MY_OPTION###"])
								$markerArray["###MY_OPTION###"] = '';
							if (!$markerArray["###MY_INPUT_RADIO###"])
								$markerArray["###MY_INPUT_RADIO###"] = '';
							if (!$markerArray["###MY_INPUT_CHECKBOX###"])
								$markerArray["###MY_INPUT_CHECKBOX###"] = '';
							if (!$markerArray["###MY_INPUT_TEXT###"])
								$markerArray["###MY_INPUT_TEXT###"] = '';
							if (!$markerArray["###MY_INPUT_WRAP###"])
								$markerArray["###MY_INPUT_WRAP###"] = '';
							
							// Questtion type
							if ($row['qtype'] == 1) {
								$answer_content = '<input type="radio" name="tx_myquizpoll_pi1[answer'.$questionNumber.']" value="'.$currentValue.'" ###MY_INPUT_RADIO### /> ';
							} else if ($row['qtype'] == 2) {
								$answer_content = '<option value="'.$currentValue.'" ###MY_OPTION###> ';
							} else if ($row['qtype'] == 3) {
								$answer_content = '<input type="text" name="tx_myquizpoll_pi1[answer'.$questionNumber.']" value="" ###MY_INPUT_TEXT### /> ';
							} else {
								$answer_content = '<input type="checkbox" name="tx_myquizpoll_pi1[answer'.$questionNumber.'_'.$currentValue.']" value="'.$currentValue.'" ###MY_INPUT_CHECKBOX### /> ';
							}
							
							if ($answerPointsBool && !$this->conf['dontShowPoints'] && !$this->conf['isPoll']) {
								$tmpPoints=intval($row['points'.$currentValue]);
								if ($row['qtype'] == 0 || $row['qtype'] == 3) {
									$markerArray["###VAR_QUESTION_POINTS###"]+=$tmpPoints;	// points for each answer
								} else if ($tmpPoints > $markerArray["###VAR_QUESTION_POINTS###"]) {
									$markerArray["###VAR_QUESTION_POINTS###"]=$tmpPoints;	// points for each answer
								}
							} else if (!$this->conf['dontShowPoints'] && !$this->conf['isPoll'] && ($row['correct'.$currentValue] || $row['qtype']==3)) {		// question-points
								$markerArray["###VAR_QUESTION_POINTS###"]+=intval($row['points']);
							}
							
							if (($row['qtype']) < 2 && !(strpos($markerArray["###MY_INPUT_WRAP###"],'|') === false)) {
								$answer_choice = str_replace('|',$answer_choice,$markerArray["###MY_INPUT_WRAP###"]);
							}
							if ($row['qtype'] != 3) $answer_content .= $answer_choice;
							if ($row['qtype'] == 2) {
								$answer_content .= "</option>\n";
								$markerArray["###VAR_QUESTION_ANSWER###"] .= $this->cObj->substituteMarkerArray($answer_content, $markerArray);
							} else {
								$markerArray['###VAR_QUESTION_ANSWER###'] = $this->cObj->substituteMarkerArray($answer_content, $markerArray);
								$markerArray["###REF_QUESTION_ANSWER###"] .= $this->cObj->substituteMarkerArray($template_answer, $markerArray);
							}
						}
					}
					
					if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] )
						$markerArray["###VAR_NEXT_POINTS###"]+=$markerArray["###VAR_QUESTION_POINTS###"];
					
					if ($this->conf['allowSkipping']) {		// skip answers
						// Questtion type
						if ($row['qtype'] == 1) {
							$answer_content = '<input type="radio" name="tx_myquizpoll_pi1[answer'.$questionNumber.']" value="-1" /> '.$this->pi_getLL('skip','skip');
						} else if ($row['qtype'] == 2) {
							$answer_content = '<option value="-1"> '.$this->pi_getLL('skip','skip').'</option>';
						} else if ($row['qtype'] == 3) {
							$answer_content = '<input type="checkbox" name="tx_myquizpoll_pi1[answer'.$questionNumber.']" value="-1" /> '.$this->pi_getLL('skip','skip');
						} else {
							$answer_content = '<input type="checkbox" name="tx_myquizpoll_pi1[answer'.$questionNumber.']" value="-1" /> '.$this->pi_getLL('skip','skip');
						}
						if ($row['qtype'] == 2) {
							$markerArray['###VAR_QUESTION_ANSWER###'] .= $answer_content;
						} else {
							$markerArray['###VAR_QUESTION_ANSWER###'] = $answer_content;
							$markerArray["###REF_QUESTION_ANSWER###"] .= $this->cObj->substituteMarkerArray($template_answer, $markerArray);
						}
					}
					
					if ($row['qtype'] == 2) {
						$markerArray["###VAR_QUESTION_ANSWER###"] .= "</select>\n";
						$markerArray["###REF_QUESTION_ANSWER###"] .= $this->cObj->substituteMarkerArray($template_answer, $markerArray);
					}
					if ( ($this->conf['userData.']['askAtQuestion'] || $questionNumber<$maxQuestions) && !$this->conf['isPoll'] ) {	// statt !$this->conf['dontShowUserData']
						$markerArray["###REF_DELIMITER###"] = $this->cObj->substituteMarkerArray($template_delimiter, $markerArray);
					} else {
						$markerArray["###REF_DELIMITER###"] = '';
					}
					
					//$this->subpart = $template;
					$template2 = $this->cObj->substituteSubpart($template, '###TEMPLATE_QUESTION_ANSWER###', $markerArray["###REF_QUESTION_ANSWER###"], 0);
					$markerArrayP["###REF_QUESTIONS###"] .= $this->cObj->substituteMarkerArray($template2, $markerArray);	// statt $content .= since 0.1.8
					$markerArrayP["###REF_QUESTIONS###"] .= '<input type="hidden" name="tx_myquizpoll_pi1[uid'.$questionNumber.']" value="'.$row['uid'].'" class="input_hidden" />';
					if ($this->conf['isPoll']) {	// link to the result page    && $this->conf['showPollResultLink']
						$urlParameters = array("tx_myquizpoll_pi1[cmd]" => "list", "tx_myquizpoll_pi1[qid]" => $row['uid'], "no_cache" => "1");
						$markerArray["###POLLRESULT_URL###"] = $this->pi_linkToPage($this->pi_getLL('poll_url','poll_url'), $listPID, $target = '', $urlParameters);
					}
					$lastUID=$row['uid'];
				}
								
				// 14.10.2009: hier wurden die Default-Namen und so gesetzt, jetzt hoeher...
				$markerArrayP["###REF_SUBMIT_FIELDS###"] = '';
				$markerArrayP["###HIDDENFIELDS###"] = '';
				
				// User-Data Template
				if ( $this->conf['userData.']['askAtQuestion'] && !$this->conf['isPoll'] ) {	// statt !$this->conf['dontShowUserData']
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_USER_TO_SUBMIT###");
					if (is_object($this->freeCap) && $this->conf['enableCaptcha']) {
						$markerArray = array_merge($markerArray, $this->freeCap->makeCaptcha());
					} else {
						$subpartArray['###CAPTCHA_INSERT###'] = '';
					}
					$markerArrayP["###REF_SUBMIT_FIELDS###"] = $this->cObj->substituteMarkerArrayCached($template,$markerArray,$subpartArray,$wrappedSubpartArray);
				} else if (!($answeredQuestions==$lastUID && $this->conf["isPoll"])) {
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_SUBMIT###");
					$markerArrayP["###REF_SUBMIT_FIELDS###"] = $this->cObj->substituteMarkerArray($template, $markerArray); // new in 0.1.8
					$markerArrayP["###HIDDENFIELDS###"] .= '  <input type="hidden" name="name" value="'.$markerArray["###DEFAULT_NAME###"].'" /> '; // statt $template .= since 0.1.8
					$markerArrayP["###HIDDENFIELDS###"] .= '  <input type="hidden" name="'.$this->prefixId.'[name]" value="'.$quizData["name"].'" />';  // wozu die Zeile davor???
					$markerArrayP["###HIDDENFIELDS###"] .= '  <input type="hidden" name="'.$this->prefixId.'[email]" value="'.$quizData["email"].'" />';
					$markerArrayP["###HIDDENFIELDS###"] .= '  <input type="hidden" name="'.$this->prefixId.'[homepage]" value="'.$quizData["homepage"].'" />';
				} else {
					$markerArray["###NO_SUBMIT###"] = $this->pi_getLL('no_submit','no_submit');
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_NO_SUBMIT###");
					$markerArrayP["###REF_SUBMIT_FIELDS###"] = $this->cObj->substituteMarkerArray($template, $markerArray); // new in 0.1.8
				}
				if (!$this->conf['isPoll']) {		// when is Poll, do not update result-table
					$markerArrayP["###HIDDENFIELDS###"] .= '  <input type="hidden" name="'.$this->prefixId.'[qtuid]" value="'.$quizData["qtuid"].'" />';  // statt $template .= since 0.1.8
				}
				//$template .= "<input type=\"hidden\" name=\"###PREFIX###[max]\" value=\"$maxPoints\">\n";  // old, deprecated since 0.1.7
				if (!$quizData["qtuid"])
					$markerArrayP["###HIDDENFIELDS###"] .= '
  <input type="hidden" name="'.$this->prefixId.'[time]" value="'.time().'" />';
				$markerArrayP["###HIDDENFIELDS###"] .= '
  <input type="hidden" name="no_cache" value="1" />
  <input type="hidden" name="'.$this->prefixId.'[cmd]" value="submit" />';
//  </form>';  // statt $template .= und old, deprecated since 0.1.8
				
				if ($this->conf['useJokers'] && $this->conf['pageQuestions']==1) {
					$markerArrayP["###HIDDENFIELDS###"] .= '
  <input type="hidden" name="'.$this->prefixId.'[joker1]" value="0" />
  <input type="hidden" name="'.$this->prefixId.'[joker2]" value="0" />
  <input type="hidden" name="'.$this->prefixId.'[joker3]" value="0" />';
				}
				
				//$content .= $this->cObj->substituteMarkerArray($template, $markerArray);  // deprecated since long time ago
				//$content .= $this->cObj->substituteMarkerArrayCached($template,$markerArray,$subpartArray,$wrappedSubpartArray); // deprecated since 0.1.8
				$questionPage = true;	
			
			} else {
			
				// final page: no more questions left, if pageQuestions > 0
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_NO_MORE###");
				$markerArray["###NO_MORE###"] = $this->pi_getLL('no_more','no_more');
				$markerArray['###YOUR_EVALUATION###'] = $this->pi_getLL('your_evaluation','your_evaluation');
				$markerArray['###REACHED1###'] = $this->pi_getLL('reached1','reached1');
				$markerArray['###REACHED2###'] = $this->pi_getLL('reached2','reached2');
				$markerArray['###POINTS###'] = $this->pi_getLL('points','points');
			/*	if ($this->conf['startPID'])		// wir sind nicht auf der Startseite, also parent holen...
					$restart_id = $this->conf['startPID']; // $GLOBALS['TSFE']->page['pid'];
				else 
					$restart_id = $GLOBALS['TSFE']->id;	*/
				$markerArray["###RESTART_QUIZ###"] = $this->pi_linkToPage($this->pi_getLL('restart_quiz','restart_quiz'), $startPID, $target = '', array());
				$questions = '';
				
				if ($this->conf['showAllCorrectAnswers'] && !$this->conf['isPoll']) {		// show all answers...
					if ($this->conf['finishAfterQuestions'])
						$fragen = intval($this->conf['finishAfterQuestions']);
					else
						$fragen = $helperObj->getQuestionsNo();
					$questions = $this->showAllAnswers( $quizData, $thePID, $tableQuestions, $tableAnswers, $tableRelation, $fragen );
				}
				
				$subpart = $template;
				$template = $this->cObj->substituteSubpart($subpart, '###QUIZ_ANSWERS###', $questions, 0);
				$markerArrayP["###REF_NO_MORE###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
				$markerArrayP["###RESTART_QUIZ###"] = $markerArray["###RESTART_QUIZ###"];
				
				if ( $this->conf['showHighscore'] ) {
					$quizData["cmd"] = 'score';
				}
				$finalPage = true;

			}
			
		} else if ($this->conf['showAnswersSeparate'] && $quizData["cmd"]=='submit' && !$this->conf['isPoll'] && $no_rights==0) { /* ***************************************************** */
			/*
			 * Display only a next button
			 */
			 
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_NEXT###");
			if ($template == '')	// if it is not in the template
				$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_NEXT###");
			$markerArrayP["###REF_NEXT###"] = $this->cObj->substituteMarkerArray($template, $markerArray);	// instead $content
		}
		
		
		
		
		/** Redirect to the final page? **/
		if ($finalPage && $quizData["cmd"] != 'exit' && $this->conf['finalPID'] && ($finalPID != intval($GLOBALS["TSFE"]->id))) {
			$uidP = $finalPID;
			header( 'Location: '.t3lib_div::locationHeaderUrl($this->pi_getPageLink($uidP,'',array($this->prefixId . '[qtuid]' => $quizData["qtuid"], $this->prefixId . '[cmd]' => 'next'))) );
			break;
		}
		
		
		// Make a page-layout
		if ( $quizData["cmd"] == 'allanswers' && !$this->conf['isPoll'] ) {    /* ***************************************************** */		
			/*
			 * Display all questions and correct answers
			 */
			$content .= $this->showAllAnswers( $quizData, $thePID, $tableQuestions, $tableAnswers, $tableRelation, $helperObj->getQuestionsNo() );
		}
		
		
		if ( $quizData["cmd"] == 'score' && !$this->conf['isPoll'] ) {         /* ***************************************************** */
			/*
			 * Display highscore page: top 10 table
			 */
			if ($quizData["setUserData"] && $quizData["qtuid"] && $quizData["name"]) {	// ggf. erst Benutzerdaten in der DB setzen...
				$uid = intval($quizData["qtuid"]);
				$firsttime = $helperObj->getFirstTime($uid);
				if ($firsttime == intval($quizData["setUserData"])) {		// Security test bestanden?
					// update current user entry
					$timestamp = time();
					// Avoid bad characters in database request
					$quiz_taker_name = $GLOBALS['TYPO3_DB']->quoteStr($quizData["name"], $tableAnswers); //addslashes($quizData["name"]);
					$quiz_taker_email  = $GLOBALS['TYPO3_DB']->quoteStr($quizData["email"], $tableAnswers); //addslashes($quizData["email"]);
					$quiz_taker_homepage = $GLOBALS['TYPO3_DB']->quoteStr($quizData["homepage"], $tableAnswers); //addslashes($quizData["homepage"]);
					$update = array('tstamp' => $timestamp,
									'name' => $quiz_taker_name,
									'email' => $quiz_taker_email,
									'homepage' => $quiz_taker_homepage);
					$success = $GLOBALS['TYPO3_DB']->exec_UPDATEquery($tableAnswers, 'uid='.$uid.' AND sys_language_uid='.$this->lang, $update);
					if(!$success){
						$content.="<p>MySQL Update-Error :-(</p>";
					}
				}
			}
			if ($finalPage)
				$markerArrayP["###REF_HIGHSCORE###"] = $this->showHighscoreList($quizData, $thePID, $tableQuestions, $tableAnswers);
			else
				$content .= $this->showHighscoreList($quizData, $thePID, $tableQuestions, $tableAnswers);
		
		} else if ( $quizData["cmd"] == 'list' && $this->conf['isPoll'] ) {    /* ***************************************************** */
			/*
			 * Display poll result
			 */
			if ($answerPage)
				$markerArrayP["###REF_POLLRESULT###"] = $this->showPollResult($answered, $quizData, $thePID, $tableQuestions, $tableAnswers);
			else
				$content .= $this->showPollResult($answered, $quizData, $thePID, $tableQuestions, $tableAnswers);
		
		} 
		
		
		if ( !$this->conf['dontShowHighscoreLink'] && !$this->conf['isPoll'] && $quizData["cmd"]!='score' ) {	// show highscore link?
  			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_HIGHSCORE_URL###");
			//if ($questionPage || $answerPage || $finalPage)
				$markerArrayP["###REF_HIGHSCORE_URL###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			//else
			//	$content .= $this->cObj->substituteMarkerArray($template, $markerArray);
  		}
		
		if ( $this->conf['isPoll'] && $quizData["cmd"]!='list' ) {	// show poll result link? && $this->conf['showPollResultLink']
  			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_POLLRESULT_URL###");
  			//if ($questionPage || $answerPage)
				$markerArrayP["###REF_POLLRESULT_URL###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			//else
			//	$content .= $this->cObj->substituteMarkerArray($template, $markerArray);
  		}

		
		/** Layout for the start page **/
		if ($startPage) {			
			$markerArrayP["###REF_PAGE_LIMIT###"] = '';
			$markerArrayP["###REF_QUIZ_LIMIT###"] = '';
			$markerArrayP["###HIDDENFIELDS###"] = '<input type="hidden" name="'.$this->prefixId.'[fromStart]" value="1" />';
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_USER_TO_SUBMIT###");
			if (is_object($this->freeCap) && $this->conf['enableCaptcha']) {
				$markerArray = array_merge($markerArray, $this->freeCap->makeCaptcha());
			} else {
				$subpartArray['###CAPTCHA_INSERT###'] = '';
			}
			$markerArrayP["###REF_SUBMIT_FIELDS###"] = $this->cObj->substituteMarkerArrayCached($template,$markerArray,$subpartArray,$wrappedSubpartArray);
				
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_PAGE###");
			if ($template == '')	// if it is not in the template
				$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_QUESTION_PAGE###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArrayP);
		}
		
		
		/** Layout for a result page **/
		if ($answerPage && $quizData["cmd"] != 'exit') {
			if ( $this->conf['quizTimeMinutes'] ) {
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_TIME_LIMIT###");
				if (!$quizData["qtuid"]) {
					$markerArray["###VAR_SECS###"] = intval($this->conf['quizTimeMinutes'])*60;
					$markerArray["###VAR_MIN###"] = $this->conf['quizTimeMinutes'];
				} else {
					$markerArray["###VAR_SECS###"] = intval($this->conf['quizTimeMinutes'])*60 - $elapseTime;
					$markerArray["###VAR_MIN###"] = round($markerArray["###VAR_SECS###"]/60);				
				}
				$markerArrayP["###REF_QUIZ_LIMIT###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			} else {
				$markerArrayP["###REF_QUIZ_LIMIT###"] = '';
			}
			
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_RESULT_PAGE###");
			if ($template == '')	// if it is not in the (old custom) template
				$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_RESULT_PAGE###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArrayP);
		}

		
		/** Layout for a questions page **/
		if ($questionPage && $quizData["cmd"] != 'exit') {
			if ( $this->conf['pageTimeSeconds'] ) {
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_PAGE_TIME_LIMIT###");
				$markerArray["###VAR_SECS###"] = $this->conf['pageTimeSeconds'];
				$markerArrayP["###REF_PAGE_LIMIT###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			} else {
				$markerArrayP["###REF_PAGE_LIMIT###"] = '';
			}
			
			if ( $this->conf['quizTimeMinutes'] ) {
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_TIME_LIMIT###");
				if (!$quizData["qtuid"]) {
					$markerArray["###VAR_SECS###"] = intval($this->conf['quizTimeMinutes'])*60;
					$markerArray["###VAR_MIN###"] = $this->conf['quizTimeMinutes'];
				} else {
					$markerArray["###VAR_SECS###"] = intval($this->conf['quizTimeMinutes'])*60 - $elapseTime;
					$markerArray["###VAR_MIN###"] = round($markerArray["###VAR_SECS###"]/60);				
				}
				$markerArrayP["###REF_QUIZ_LIMIT###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
//				$markerArrayP["###HIDDENFIELDS###"] .= '
//  <input type="hidden" name="'.$this->prefixId.'[cancel]" value="0">';
			} else {
				$markerArrayP["###REF_QUIZ_LIMIT###"] = '';
			}
			
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_PAGE###");
			if ($template == '')	// if it is not in the template
				$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_QUESTION_PAGE###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArrayP);
		}
		
		
		/** Layout for the last/final page **/
		if ($finalPage && $quizData["cmd"] != 'exit' && !$this->conf['isPoll']) {
			if ($this->conf['showAnalysis'] && !$this->conf['dontShowPoints'] && $markerArray["###VAR_TMAX_POINTS###"]) {	// Analysis depends on points
				$percent = 100 * $markerArray["###VAR_TOTAL_POINTS###"] / $markerArray["###VAR_TMAX_POINTS###"];	// genauerer wert...
				$markerArray["###VAR_PERCENT###"] = intval($percent);
				$markerArray["###REACHED1###"] = $this->pi_getLL('reached1','reached1');
				$markerArray["###REACHED2###"] = $this->pi_getLL('reached2','reached2');
				$percentsArray = split(',', $this->conf['showAnalysis']);
				$percentTemplateNo = '';
				$p = 0;
				$uidP = 0;
				while ($p < count($percentsArray)) {
					$percentTemplateNo = $percentsArray[$p];
					if (strpos($percentTemplateNo, ':') !== false) {
						list($percentTemplateNo, $uidP) = split(":", $percentTemplateNo);
					}
					if ($percent <= floatval($percentTemplateNo)) {
						if ($uidP)		// redirect to a URL with that UID
							header('Location: '.t3lib_div::locationHeaderUrl($this->pi_getPageLink($uidP,'',array($this->prefixId.'[name]'=>$quizData["name"],$this->prefixId.'[email]'=>$quizData["email"],$this->prefixId.'[homepage]'=>$quizData["homepage"]))));
						break;
					}
					$p++;
				}
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_ANALYSIS_$percentTemplateNo###");
				$markerArrayP["###REF_QUIZ_ANALYSIS###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			}
			
			$markerArrayP["###FORM_URL###"] = $this->pi_getPageLink($listPID);		// zur entgueltig letzten seite wechseln
			$markerArrayP["###REF_SUBMIT_FIELDS###"] = '';
			$markerArrayP["###HIDDENFIELDS###"] = '';
			if ( $this->conf['userData.']['showAtFinal'] ) {
				// Avoid bad characters in database request
				$quiz_taker_name = $GLOBALS['TYPO3_DB']->quoteStr($quizData["name"], $tableAnswers); //addslashes($quizData["name"]);
				$quiz_taker_email  = $GLOBALS['TYPO3_DB']->quoteStr($quizData["email"], $tableAnswers); //addslashes($quizData["email"]);
				$quiz_taker_homepage = $GLOBALS['TYPO3_DB']->quoteStr($quizData["homepage"], $tableAnswers); //addslashes($quizData["homepage"]);				
				$markerArray["###REAL_NAME###"] = $quiz_taker_name;
				$markerArray["###REAL_EMAIL###"] = $quiz_taker_email;
				$markerArray["###REAL_HOMEPAGE###"] = $quiz_taker_homepage;
				$markerArray["###RESULT_FOR###"] = $this->pi_getLL('result_for','result_for');
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_USER_SUBMITED###"); // Output the user name
				$markerArrayP["###REF_INTRODUCTION###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			}
			
			// User-Data Template
			if ( $this->conf['userData.']['askAtFinal'] && $quizData["qtuid"] ) {
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_USER_TO_SUBMIT###");
				if (is_object($this->freeCap) && $this->conf['enableCaptcha']) {
					$markerArray = array_merge($markerArray, $this->freeCap->makeCaptcha());
				} else {
					$subpartArray['###CAPTCHA_INSERT###'] = '';
				}
				$firsttime = $helperObj->getFirstTime($quizData["qtuid"]);
				$markerArrayP["###REF_SUBMIT_FIELDS###"] = $this->cObj->substituteMarkerArrayCached($template,$markerArray,$subpartArray,$wrappedSubpartArray);
				$markerArrayP["###HIDDENFIELDS###"] = "\n".'  <input type="hidden" name="'.$this->prefixId.'[qtuid]" value="'.$quizData["qtuid"].'" />'."\n";
				$markerArrayP["###HIDDENFIELDS###"] .= '  <input type="hidden" name="'.$this->prefixId.'[setUserData]" value="'.$firsttime.'" />';
			}
			
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_FINAL_PAGE###");
			if ($template == '')	// if it is not in the template
				$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_QUIZ_FINAL_PAGE###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArrayP);
		}
		
		
		return $this->pi_wrapInBaseClass($content);
	}



	
	// show all answers
	function showAllAnswers($quizData, $thePID, $tableQuestions, $tableAnswers, $tableRelation, $questionsTotal) {
		$questions = '';
		$statHash = array();
		$userHash = array();
		if ($this->conf['advancedStatistics']) {	// load and show advanced statistics
			$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('sum(checked1),sum(checked2),sum(checked3),sum(checked4),sum(checked5), uid_foreign',
				$tableRelation.', tx_myquizpoll_relation_question_id_mm',
				'uid=uid_local AND pid='.$thePID.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableRelation),
				'uid_foreign',
				'',
				'');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
			if ($rows>0) {
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){
					$qno = $row['uid_foreign'];
					$statHash[$qno]['c1'] = $row['sum(checked1)'];
					$statHash[$qno]['c2'] = $row['sum(checked2)'];
					$statHash[$qno]['c3'] = $row['sum(checked3)'];
					$statHash[$qno]['c4'] = $row['sum(checked4)'];
					$statHash[$qno]['c5'] = $row['sum(checked5)'];
				}
			}
			$GLOBALS['TYPO3_DB']->sql_free_result($res5); 
			//print_r($statHash);
			
			if ($quizData["qtuid"]) {
				$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('checked1,checked2,checked3,checked4,checked5,points,textinput, tx_myquizpoll_relation_question_id_mm.uid_foreign',
					$tableRelation.', tx_myquizpoll_relation_question_id_mm, tx_myquizpoll_relation_user_id_mm',
					'uid=tx_myquizpoll_relation_question_id_mm.uid_local AND uid=tx_myquizpoll_relation_user_id_mm.uid_local AND tx_myquizpoll_relation_user_id_mm.uid_foreign='.$quizData["qtuid"].' AND pid='.$thePID.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableRelation),
					'',
					'',
					'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
				if ($rows>0) {
					while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){
						$qno = $row['uid_foreign'];
						$userHash[$qno]['c1'] = $row['checked1'];
						$userHash[$qno]['c2'] = $row['checked2'];
						$userHash[$qno]['c3'] = $row['checked3'];
						$userHash[$qno]['c4'] = $row['checked4'];
						$userHash[$qno]['c5'] = $row['checked5'];
						$userHash[$qno]['textinput'] = $row['textinput'];
						$userHash[$qno]['points'] = $row['points'];
					}
				}
				$GLOBALS['TYPO3_DB']->sql_free_result($res5);
			}
			//print_r($userHash);
			
			$template_okok = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR_ANSW###");
			$template_notok = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_NOTCORR_ANSW###");
		}
		$template_oknot = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR_NOTANSW###");
		$template_notnot = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_NOTCORR_NOTANSW###");
		
		if ($quizData["cmd"] == 'allanswers') {
			$template_entry = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_ALLANSWERS###");
		} else {
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_NO_MORE###");
			$template_entry = $this->cObj->getSubpart($template, "###QUIZ_ANSWERS###");		
		}
		$template_answer = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR###");
		$template_expl = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_EXPLANATION###");
		$template_delimiter = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_DELIMITER###");
		$template_image_begin = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_IMAGE_BEGIN###");
		$template_image_end = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_IMAGE_END###");

		$imgTSConfig = array();
		$myAArray = array();
		$markerArrayS = array();
		$markerArrayS["###PREFIX###"] = $this->prefixId;
		$markerArrayS["###EXPLANATION###"] = $this->pi_getLL('listFieldHeader_explanation','listFieldHeader_explanation');
		if ( !$this->conf['dontShowPoints'] ) {
			$markerArrayS["###P1###"] = $this->pi_getLL('p1','p1');
			$markerArrayS["###P2###"] = $this->pi_getLL('p2','p2');
			$markerArrayS["###NO_POINTS###"] = '0';
		} else {
			$markerArrayS["###P1###"] = '';
			$markerArrayS["###P2###"] = '';
			$markerArrayS["###NO_POINTS###"] = '';
		}
		$markerArrayS["###VAR_QUESTIONS###"] = $questionsTotal;
		
		$sortBy = 'sorting';
		if ( $this->conf['sortBy'] ) {
			switch ($this->conf['sortBy']) {
				case "sorting": $sortBy = "sorting"; break;
				case "uid": $sortBy = "uid"; break;
				case "title": $sortBy = "title"; break;
				default: $sortBy = "sorting"; break;
			}
		}
		
		// Get all questions and answers from the database
		$questionsArray = array();
		$questionNumber = 0;
		$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
				$tableQuestions,
				'pid='.$thePID.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableQuestions),
				'',
				$sortBy,
				'');
		$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
		if ($rows>0) {
			while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){
				$questionUID = $row['uid'];
				
				if ($this->conf['advancedStatistics'] && $quizData["qtuid"] and !is_array($userHash[$questionUID]))
					continue;				// vorher nicht angezeigte Fragen auch jetzt nicht anzeigen! 
				
				$questionNumber++;
				$answerPointsBool = false;
				$markerArrayS["###VAR_QUESTION###"] = $questionNumber;
				$markerArrayS["###VAR_QUESTION_TITLE###"] = $row['title'];
				$markerArrayS["###VAR_QUESTION_NAME###"] = $row['name'];
				$markerArrayS["###REF_QR_ANSWER_CORR###"] = '';
				$markerArrayS["###REF_QR_ANSWER_ALL###"] = '';
				$markerArrayS["###REF_QR_EXPLANATION###"] = '';
				if ($questionNumber < $rows) {
					$markerArrayS["###REF_DELIMITER###"] = $this->cObj->substituteMarkerArray($template_delimiter, $markerArrayS);
				} else {
					$markerArrayS["###REF_DELIMITER###"] = '';
				}				
				if ( $row['explanation']!='' ) {	// Explanation
					$markerArrayS["###VAR_EXPLANATION###"] = $row['explanation'];
					$markerArrayS["###REF_QR_EXPLANATION###"] = $this->cObj->substituteMarkerArray($template_expl, $markerArrayS);
				}
				if ($row['image']) {
					$imgTSConfig['file'] = 'uploads/tx_myquizpoll/'.$row['image']; //The image field name
					$imgTSConfig['altText'] = $row["alt_text"];
					$imgTSConfig['titleText'] = $row["alt_text"];
					if (is_array($this->conf['images.'])) {
						$imgTSConfig['file.']['maxW'] = $this->conf['images.']['maxW'];
						$imgTSConfig['file.']['maxH'] = $this->conf['images.']['maxH'];
					}
					$markerArrayS["###VAR_QUESTION_IMAGE###"] = $this->cObj->IMAGE($imgTSConfig);	// statt $this->conf["image."]
					$markerArrayS["###REF_QUESTION_IMAGE_BEGIN###"] = $this->cObj->substituteMarkerArray($template_image_begin, $markerArrayS);
					$markerArrayS["###REF_QUESTION_IMAGE_END###"] = $template_image_end;
				} else {
					$markerArrayS["###REF_QUESTION_IMAGE_BEGIN###"] = '';
					$markerArrayS["###REF_QUESTION_IMAGE_END###"] = '';
				}
				if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] ) {
					for ($currentValue=1; $currentValue <= $this->answerChoiceMax; $currentValue++) {
						if (intval($row['points'.$currentValue])>0 ) {
							$answerPointsBool = true;
							break;
						}
					}
				}
				
				if (is_array($this->conf['myVars.']['questions.'])) {
					foreach($this->conf['myVars.']['questions.'] as $key => $value) {
						$myQArray = split(',', $value);
						$myKey = ($questionNumber-1)%count($myQArray);
						$markerArrayS["###MY_".strtoupper($key)."###"] = $myQArray[$myKey];
					}
				}
					
				for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {
					if ($row['answer'.$answerNumber]) {	// was a answer set in the backend?
						
						if (is_array($this->conf['myVars.']['answers.'])) {						// custom variables
							foreach($this->conf['myVars.']['answers.'] as $key => $value) {
								$myAArray = split(',', $value);
								$myKey = ($answerNumber-1)%count($myAArray);
								$markerArrayS["###MY_".strtoupper($key)."###"] = $myAArray[$myKey];
							}
						}
							
					//	if ($this->conf['advancedStatistics'] and $quizData["qtuid"]) {
							$tempAnswer = '';
							$markerArrayS['###VAR_QUESTION_ANSWER###'] = $row['answer'.$answerNumber];
							if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] ) {
								if ($answerPointsBool)
									$markerArrayS["###VAR_ANSWER_POINTS###"] = intval($row['points'.$answerNumber]);
									if ($markerArrayS["###VAR_ANSWER_POINTS###"] > 0)
										$row['correct'.$answerNumber] = true;		// ACHTUNG: falls Punkte zu einer Antwort gesetzt sind, dann wird die Antwort als RICHTIG bewertet!
								else 
									$markerArrayS["###VAR_ANSWER_POINTS###"] = intval($row['points']);
							} else {
								$markerArrayS["###VAR_ANSWER_POINTS###"] = '';
							}
							if ($this->conf['advancedStatistics']) {
								if ($statHash[$questionUID]['c1']+$statHash[$questionUID]['c2']+$statHash[$questionUID]['c3']+$statHash[$questionUID]['c4']+$statHash[$questionUID]['c5'] > 0)
									$markerArrayS['###VAR_PERCENT###'] = number_format(100 * $statHash[$questionUID]['c'.$answerNumber] / ($statHash[$questionUID]['c1']+$statHash[$questionUID]['c2']+$statHash[$questionUID]['c3']+$statHash[$questionUID]['c4']+$statHash[$questionUID]['c5']), 2, ',', ' ');
								else
									$markerArrayS['###VAR_PERCENT###'] = '0';
								$markerArrayS['###VAR_COUNTS###'] = $statHash[$questionUID]['c'.$answerNumber];
							}
							
							if ($this->conf['advancedStatistics'] and $quizData["qtuid"] && $userHash[$questionUID]['c'.$answerNumber] && ( ($row['qtype']==3 && strtolower($row['answer'.$answerNumber])==strtolower($userHash[$questionUID]['textinput'])) ||
											($row['qtype']< 3 && $row['correct'.$answerNumber]) )) {
								$tempAnswer = $this->cObj->substituteMarkerArray($template_okok, $markerArrayS);
							} else if ($this->conf['advancedStatistics'] and $quizData["qtuid"] && $userHash[$questionUID]['c'.$answerNumber]) {											
								$tempAnswer = $this->cObj->substituteMarkerArray($template_notok, $markerArrayS);
							} else if ($row['correct'.$answerNumber]) {
								$tempAnswer = $this->cObj->substituteMarkerArray($template_oknot, $markerArrayS);
								if ($this->conf['advancedStatistics'] and $quizData["qtuid"] && $row['qtype']==3 && $userHash[$questionUID]['textinput']) {		// falsche antwort und richtige antwort ausgeben; hier gibt es 2 antworten !!!
									$markerArrayS["###VAR_QUESTION_ANSWER###"] = $userHash[$questionUID]['textinput'];		// falschen werte berechnen...
									if ($statHash[$questionUID]['c1']+$statHash[$questionUID]['c2']+$statHash[$questionUID]['c3']+$statHash[$questionUID]['c4']+$statHash[$questionUID]['c5'] > 0)
										$markerArrayS['###VAR_PERCENT###'] = number_format(100 * $statHash[$questionUID]['c2'] / ($statHash[$questionUID]['c1']+$statHash[$questionUID]['c2']), 2, ',', ' ');
									else
										$markerArrayS['###VAR_PERCENT###'] = '0';
									$markerArrayS['###VAR_COUNTS###'] = $statHash[$questionUID]['c2'];
									$tempAnswer .= $this->cObj->substituteMarkerArray($template_notok, $markerArrayS);
								}
							} else {
								$tempAnswer = $this->cObj->substituteMarkerArray($template_notnot, $markerArrayS);
							}
							$markerArrayS["###REF_QR_ANSWER_ALL###"] .= $tempAnswer;		// all answers in correct order
					
					//	} else 
						if ($row['correct'.$answerNumber] || $row['qtype']==3) { // all correct answers
					//		$markerArrayS["###VAR_QUESTION_ANSWER###"] = $row['answer'.$answerNumber];
							$markerArrayS["###REF_QR_ANSWER_CORR###"] .= $this->cObj->substituteMarkerArray($template_answer, $markerArrayS);
						}
					}
				}
				
				if ($this->conf['advancedStatistics'] and $quizData["qtuid"]) {
					$markerArrayS['###RESULT_QUESTION_POINTS###'] = $this->pi_getLL('result_question_points','result_question_points');
					$markerArrayS['###VAR_POINTS###'] = $userHash[$questionUID]['points'];
				}
				
				$questions .= $this->cObj->substituteMarkerArray($template_entry, $markerArrayS);
			}
		}
		$GLOBALS['TYPO3_DB']->sql_free_result($res5);
		return $questions;
	}
	
	
	// show highscore list
	function showHighscoreList($quizData, $thePID, $tableQuestions, $tableAnswers) {
	
			$nr=0;
			$limit='';
			$date_format='m-d-Y';
			if ( $this->conf['dateFormat'] ) { $date_format=$this->conf['dateFormat']; } // date format
			
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_HIGHSCORE###");
			$template_entry = $this->cObj->getSubpart($template, "###TEMPLATE_HIGHSCORE_ENTRY###");
			$template_caption = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_HIGHSCORE_CAPTION###");
			$template_quiz_taker = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_HIGHSCORE_QUIZ_TAKER###");
			
			$markerArray=array();
			$markerArrayH=array();
			$markerArrayS=array();
			$markerArray["###PREFIX###"] = $this->prefixId;
			$markerArray["###REF_HIGHSCORE_CAPTION###"] = '';
			$markerArray["###REF_HIGHSCORE_ENTRY###"] = '';
			
			if ( $this->conf['highscoreEntries']>0 ) {
				$markerArray["###HIGHSCORE_CAPTION###"] = $this->pi_getLL('highscore_caption','highscore_caption');
				$markerArray["###VAR_HIGHSCORE_LIMIT###"] = $this->conf['highscoreEntries'];
				$markerArray["###REF_HIGHSCORE_CAPTION###"] = $this->cObj->substituteMarkerArray($template_caption, $markerArray);
				$limit = $this->conf['highscoreEntries'];
			}
			
			$markerArray["###NUMBER###"] = $this->pi_getLL('number','number');
			$markerArray["###POINTS###"] = $this->pi_getLL('points','points');
			$markerArray["###PERCENT###"] = $this->pi_getLL('percent','percent');
			$markerArray["###TIME###"] = $this->pi_getLL('time','time');
			$markerArray["###NAME###"] = $this->pi_getLL('name','name');
			$markerArray["###DATE###"] = $this->pi_getLL('date','date');
			
			if ( $this->conf['sortHighscoreBy']=='percent' ) {
				$orderBy='percent DESC';
			} else if ( $this->conf['sortHighscoreBy']=='o_percent' ) {
				$orderBy='o_percent DESC';
			} else if ( $this->conf['sortHighscoreBy']=='time' ) {
				$orderBy='(lasttime-firsttime) ASC';
			} else {
				$orderBy='p_or_a DESC';
			}
			
			$res4 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid,p_or_a,p_max,percent,o_max,o_percent,lasttime,firsttime,name,email,homepage,tstamp',
					$tableAnswers,
					'pid='.$thePID.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableAnswers),
					'',
					$orderBy.', sorting DESC',
					$limit);
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res4);
			if ($rows>0) {
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res4)){
					$aDate = date($date_format, $row['tstamp']);
					$aTime = mktime(0, 0, 0, 1, 1, 2009);
					$aTime += intval($row['lasttime'])-intval($row['firsttime']); // - 60*60;	// - 1 Stunde, warum auch immer das noetig ist...
					$aTime = date('G:i:s', $aTime);
					
					if ($row['uid'] == $quizData["qtuid"]) {		// aktueller eintrag
						$markerArrayS["###EVEN_ODD###"] = $markerArrayS["###MY_EVEN_ODD###"] = '-act';
					} else {
						if (is_array($this->conf['myVars.']['list.'])) {
							foreach($this->conf['myVars.']['list.'] as $key => $value) {
								$myQArray = split(',', $value);
								$myKey = ($nr)%count($myQArray);
								$markerArrayS["###MY_".strtoupper($key)."###"] = $myQArray[$myKey];
							}
						} else {		// aus kompatibilitaetsgruenden
							if (($nr % 2) == 0) {
								$markerArrayS["###EVEN_ODD###"] = ' tr-even';
							} else {
								$markerArrayS["###EVEN_ODD###"] = ' tr-odd';
							}
							$markerArrayS["###MY_EVEN_ODD###"] = $markerArrayS["###EVEN_ODD###"];	// hinzugefuegt am 2.9.2009
						}
					}
					
					$markerArrayH["###VAR_NAME###"] = $row['name'];
					$markerArrayH["###VAR_EMAIL###"] = $row['email'];
					$markerArrayH["###VAR_HOMEPAGE###"] = $row['homepage'];
					if ($row['homepage'] != "" && $row['homepage'] != $this->pi_getLL('no_homepage','no_homepage')) {
						$url_http=$row['homepage'];
						if (substr($url_http, 0,4) != 'http')
							$url_http='http://'.$url_http;
						$markerArrayH["###VAR_TO_HOMEPAGE###"] = "<a href=\"".$url_http."\" target=\"hp\">-&gt; ".$this->pi_getLL('homepage','homepage')."</a><br/>";
					} else {
						$markerArrayH["###VAR_TO_HOMEPAGE###"] = '';
					}
					$markerArrayH["###VAR_NAME_AND_EMAIL###"] = $row['name']."<br/>\n";
					if ($row['email'] != "" && $row['email'] != $this->pi_getLL('no_email','no_email')) {
						$email_crypt = $GLOBALS['TSFE']->encryptEmail('mailto:'.$row['email']); 
						if ($email_crypt == 'mailto:'.$row['email']) {		// Bug fixed: not always linkTo_UnCryptMailto
							$nameandemail = $email_crypt;
						} else {
							$nameandemail = "javascript:linkTo_UnCryptMailto('".$email_crypt."')";
						}
						$markerArrayH["###VAR_NAME_AND_EMAIL###"] = '<a href="'.$nameandemail.'">'.$row['name']."</a><br/>\n";
					}
					$markerArrayS["###REF_HIGHSCORE_QUIZ_TAKER###"] = $this->cObj->substituteMarkerArray($template_quiz_taker, $markerArrayH);
					
					$markerArrayS["###VAR_COUNT###"] = $nr+1;
					$markerArrayS["###VAR_POINTS###"] = $row['p_or_a'];
					$markerArrayS["###VAR_MAX###"] = $row['p_max'];
					$markerArrayS["###VAR_O_MAX###"] = $row['o_max'];
					$markerArrayS["###VAR_PERCENT###"] = $row['percent'];
					$markerArrayS["###VAR_O_PERCENT###"] = $row['o_percent'];
					$markerArrayS["###VAR_TIME###"] = $aTime;
					$markerArrayS["###VAR_DATE###"] = $aDate;
					$markerArray["###REF_HIGHSCORE_ENTRY###"] .= $this->cObj->substituteMarkerArray($template_entry, $markerArrayS);
					
					$nr++;
				}
			}
			$GLOBALS['TYPO3_DB']->sql_free_result($res4); 
			$subpart = $template;
			$template = $this->cObj->substituteSubpart($subpart, '###TEMPLATE_HIGHSCORE_ENTRY###', $markerArray["###REF_HIGHSCORE_ENTRY###"], 0);
			$out = $this->cObj->substituteMarkerArray($template, $markerArray);
			return $out;
	}
	
	
	// show poll result
	function showPollResult($answered, $quizData, $thePID, $tableQuestions, $tableAnswers) {
	
			// poll answers
			$votes=0;
			$hits=0;
			$percent=0;

			if (!$answered) {	// link clicked?
				$answered = $quizData["qid"];
			}
			if ($answered) {
				$answeredP = ' AND uid='.$answered;
				$answeredQ = ' AND qids='.$answered;
			}
			
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_POLLRESULT###");
			$template_entry = $this->cObj->getSubpart($template, "###TEMPLATE_POLLRESULT_ENTRY###");
			
			$markerArray=array();
			$markerArrayS=array();
			$markerArray["###PREFIX###"] = $this->prefixId;
			$markerArray["###REF_POLLRESULT_ENTRY###"] = '';
			$markerArray["###ANSWER###"] = $this->pi_getLL('answer','answer');
			$markerArray["###VOTES###"] = $this->pi_getLL('votes','votes');
			
			// poll question
			$query = 'SELECT * FROM '.$tableQuestions.' WHERE pid='.$thePID.$answeredP.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableQuestions);
			$queryResult = mysql( TYPO3_db, $query );
//			echo mysql_error();
			$row = mysql_fetch_assoc($queryResult);
			
			$markerArray["###VAR_QUESTION_TITLE###"] = $row['title'];
			$markerArray["###VAR_QUESTION_NAME###"] = $row['name'];
			
			// votes
			$res2 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('count(p_or_a), p_or_a',
					$tableAnswers,
					'pid='.$thePID.$answeredQ.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableAnswers),
					'p_or_a',
					'p_or_a',
					'');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res2);
			if ($rows>0) {
				while($row2 = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res2)){
					$aAnswer=$row2['p_or_a'];
					if ($aAnswer) {		// since 0.2.1
						$row['votes'.$aAnswer]=$row2['count(p_or_a)'];	// Votes for a answer
						$votes+=$row2['count(p_or_a)'];
					}
				}
			}
			
			// show the answers and votes
			for ($nr=1; $nr<=$this->answerChoiceMax; $nr++) {
			  if ($row['answer'.$nr]) {
				if (is_array($this->conf['myVars.']['list.'])) {
					foreach($this->conf['myVars.']['list.'] as $key => $value) {
						$myQArray = split(',', $value);
						$myKey = ($nr-1)%count($myQArray);
						$markerArrayS["###MY_".strtoupper($key)."###"] = $myQArray[$myKey];
					}
				} else {
					$markerArrayS["###EVEN_ODD###"] = (($nr % 2) == 0) ? ' tr-even' : ' tr-odd';
				}
						
				$markerArrayS["###VAR_ANSWER###"] = $row['answer'.$nr];
				if ($row['votes'.$nr]) {
					$hits=$row['votes'.$nr];
					$percent=round(100*$row['votes'.$nr]/$votes, 2);
				} else {
					$hits=0;
					$percent=0;
				}
				$markerArrayS["###VAR_HITS###"] = $hits;
				$markerArrayS["###VAR_PERCENT###"] = $percent;
				$markerArray["###REF_POLLRESULT_ENTRY###"] .= $this->cObj->substituteMarkerArray($template_entry, $markerArrayS);
				$markerArray["###VAR_ANSWER$nr###"] = $markerArrayS["###VAR_ANSWER###"];
				$markerArray["###VAR_HITS$nr###"] = $markerArrayS["###VAR_HITS###"];
				$markerArray["###VAR_PERCENT$nr###"] = $markerArrayS["###VAR_PERCENT###"];
			  }
			}
			$markerArray["###VAR_VOTES###"] = $votes;
			$this->subpart = $template;
			$template = $this->cObj->substituteSubpart($this->subpart, '###TEMPLATE_POLLRESULT_ENTRY###', $markerArray["###REF_POLLRESULT_ENTRY###"], 0);
			$out = $this->cObj->substituteMarkerArray($template, $markerArray);
			mysql_free_result($queryResult);
			return $out;
	}
	
	
	/**
	 * Format string with nl2br and htmlspecialchars()
	 */
	function formatStr($str)	{
		if (is_array($this->conf["general_stdWrap."]))	{
			$str = $this->local_cObj->stdWrap($str,$this->conf["general_stdWrap."]);
		}
		return $str;
	}
	
	
	/**
    * read the template file, fill in global wraps and markers and write the result
    * to '$this->templateCode'
    *
    * @return    void
    */
	function initTemplate() {
       // read template-file
       $templateFile = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'templateFile');
       $origTemplateFile = 'EXT:myquizpoll/pi1/tx_myquizpoll_pi1.tmpl';	
	   if ($templateFile) {
           if (false === strpos($templateFile, '/')) {
               $templateFile = 'uploads/tx_myquizpoll/' . $templateFile;
           }
       } else if ($this->conf['templateFile']) {
           $templateFile = $this->conf['templateFile'];
       } else {
	   	   $templateFile = $origTemplateFile;		  
       }
	   $this->templateCode = $this->cObj->fileResource($templateFile);
	   $this->origTemplateCode = $this->cObj->fileResource($origTemplateFile);
	} 

   
	/**
    * copy flexform-values to '$this->conf'
    *
    * @return    void
    */
	function copyFlex() {
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'what_to_display');
		if ($value and $value!='TS') {
			if ($value=='NORMAL')
				$this->conf['CMD'] = '';
			else
				$this->conf['CMD'] = $value;
		}
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'isPoll');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['isPoll'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'nextPID');
		if ($value)
			$this->conf['nextPID'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'finalPID');
		if ($value)
			$this->conf['finalPID'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'startPID');
		if ($value)
			$this->conf['startPID'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'listPID');
		if ($value)
			$this->conf['listPID'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'pageQuestions');
		if ($value || $value==='0' || $value===0)
			$this->conf['pageQuestions'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'quizName');
		if ($value)
			$this->conf['quizName'] = $value;
			
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'sortBy', 'sNEXT');
		if ($value and $value!='TS')
			$this->conf['sortBy'] = $value;
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showAnswersSeparate', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['showAnswersSeparate'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'dontShowCorrectAnswers', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['dontShowCorrectAnswers'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showAllCorrectAnswers', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['showAllCorrectAnswers'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'allowSkipping', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['allowSkipping'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'dontShowPoints', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['dontShowPoints'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'noNegativePoints', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['noNegativePoints'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'userSession', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['userSession'] = intval($value);
		
		//if ($this->conf['dontShowUserResult']) // und dann???
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'askAtStart', 'sUSERDATA');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['userData.']['askAtStart'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'askAtQuestion', 'sUSERDATA');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['userData.']['askAtQuestion'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'askAtFinal', 'sUSERDATA');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['userData.']['askAtFinal'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showAtAnswer', 'sUSERDATA');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['userData.']['showAtAnswer'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showAtFinal', 'sUSERDATA');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['userData.']['showAtFinal'] = intval($value);
		if ($this->conf['dontShowUserData']) 	// aus Kompatibilitaetsgruenden
			$this->conf['userData.']['askAtQuestion'] = 0;
		
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'useJokers', 'sFEATURES');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['useJokers'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'jokersUnlimited', 'sFEATURES');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['jokers.']['unlimited'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'jokersHalvePoints', 'sFEATURES');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['jokers.']['halvePoints'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'advancedStatistics', 'sFEATURES');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['advancedStatistics'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'enableCaptcha', 'sFEATURES');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['enableCaptcha'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'loggedInCheck', 'sFEATURES');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['loggedInCheck'] = intval($value);
	}


#
############################################################

	function getAjaxData($quid,$ruid,$jokerNo,$jokerName) {
		$sOut = '';
		$jsc = '';
		$nCount = 0;
		if ($this->conf['answerChoiceMax'])					// antworten pro fragen
			$this->answerChoiceMax = intval($this->conf['answerChoiceMax']);
			
		// DB-Anfrage nach Typo3-Coding-Guidline
		$result = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
			'*', // SELECT ...
			'tx_myquizpoll_question', // FROM ...
			'uid='.intval($quid), // WHERE...
			'', // GROUP BY...
			'', // ORDER BY...
			'' // LIMIT ...
		);
		$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($result);
		if ($jokerNo==1) {
			for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {						
				if ($row['joker1_'.$answerNumber]) {
					$sOut .= '; '.$row['answer'.$answerNumber];
				} else if ($row['answer'.$answerNumber]) {
					$jsc .= ", 'quiz_antwort$answerNumber'";
				}
			}
			$sOut = substr($sOut,2);
		} else if ($jokerNo==2) {
			for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {						
				if ($row['answer'.$answerNumber]) {
					$sOut .= '; '.$row['answer'.$answerNumber].': '.$row['joker2_'.$answerNumber].'%';
				}
			}
			$sOut = substr($sOut,2);
		} else if ($jokerNo==3) {
			$sOut = $row['joker3'];
		}
		if (!$sOut) $sOut = $this->pi_getLL('no_joker_answer','no_joker_answer');;
		
		if ($ruid > 0) {				// which Joker used?
			$timestamp = time();
			$update = array('tstamp' => $timestamp,
							'joker'.$jokerNo => 1,
							'lasttime' => $timestamp);
			$success = $GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_myquizpoll_result', 'uid='.intval($ruid).' AND sys_language_uid='.$this->lang, $update);
			if(!$success){
				$content.="<p>MySQL Update-Error :-(</p>";
			}
		}
		
		/* instantiate the xajaxResponse object */
		$objResponse = new tx_xajax_response();
		$objResponse->addScript("document.getElementById('".$this->prefixId."-joker').style.display = \"block\"");
		$objResponse->addScript("document.getElementById('".$this->prefixId."-$jokerName').style.display = \"none\"");
		
//		if(!$ruid)	{			// 9.8.09: man soll immer feststellen koennen, ob ein Joker benutzt wurde
			$objResponse->addScript('document.forms["myquiz"].elements["'.$this->prefixId.'[joker'.$jokerNo.']"].value = 1');
//			$objResponse->addScript("document.getElementById('".$box."').value = 1");
//		}
		
		if ($jsc) {
			$jsc = substr($jsc,2);
			$objResponse->addScript('hideByJoker ('.$jsc.')');
		}
		
		/* We alter the contents of the 'joker' HTML element. The property 'innerHTML' is the html code inside this element. We replace it with the result in our $sOut variable */
		$objResponse->addAssign($this->prefixId."-joker_answer", "innerHTML", $sOut);  
		/* With the getXML() method on the xajaxResponse objectwe send everything back to the client */
		return $objResponse->getXML();
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/myquizpoll/pi1/class.tx_myquizpoll_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/myquizpoll/pi1/class.tx_myquizpoll_pi1.php']);
}

?>